;******************************************************************************************
;*															*
;*	Anschlu einer PS2-Tastatur an einen KC85/3							*
;*															*
;******************************************************************************************
;* 	Pinbelegung													*
;*	---------------------------------------								*
;*	PORTA:	0 als Ausgang nicht benutzt								*
;*			1 als Ausgang nicht benutzt								*
;*			2 als Ausgang nicht benutzt								*
;*			3 als Ausgang nicht benutzt								*
;*			4 als Ausgang nicht benutzt 								*
;*			5 als Ausgang nicht benutzt								*
;*															*
;*	PORTB:	0 als Ausgang nicht benutzt								*
;*			1 als Ausgang nicht benutzt								*
;*			2 als Ausgang nicht benutzt 								*
;*			3 Daten zum Koppler zwischen PIC und KC						*
;*			4 als Ausgang nicht benutzt								*
;*			5 als Ausgang nicht benutzt								*
;*			6 als Ausgang nicht benutzt 								*
;*			7 als Ausgang nicht benutzt								*
;*															*
;*	PORTC:	0 als Ausgang nicht benutzt								*
;*			1 als Ausgang nicht benutzt								*
;*			2 als Ausgang nicht benutzt 								*
;*			3 als Ausgang nicht benutzt								*
;*			4 als Ausgang nicht benutzt								*
;*			5 als Ausgang nicht benutzt								*
;*			6 als Ausgang nicht benutzt 								*
;*			7 als Ausgang nicht benutzt								*
;*															*
;*	PORTD:	0 als Ausgang nicht benutzt								*
;*			1 als Ausgang nicht benutzt								*
;*			2 als Ausgang nicht benutzt 								*
;*			3 als Ausgang nicht benutzt								*
;*			4 als Ausgang nicht benutzt								*
;*			5 als Ausgang nicht benutzt								*
;*			6 als Ausgang nicht benutzt 								*
;*			7 als Ausgang nicht benutzt								*
;*															*
;*	PORTE:	0 PS2 Tastatur DATA									*
;*			1 PS2 Tastatur CLK									*
;*			2 als Ausgang nicht benutzt 								*
;*															*
;* 	Wiedner (GW) 08/2006 (letzte nderung 24.02.2008)						*
;*															*
;*															*
;* 	PIC16F877													*
;* 	Tektquelle: 20 MHz Quarz										*
;*	Option:													*
;*															*
;******************************************************************************************
;
	list p = 16f877
;
;**** COMPILATION MESSAGES & WARNINGS *****************************************************
;
 	ERRORLEVEL -207 				; Found label after column 1.
 	ERRORLEVEL -302 				; Register in operand not in bank 0.
;	ERRORLEVEL -306				; Programm ger 2K 
;	
;****	Includedatei fr den 16F877 einbinden ***********************************************
;
	#include <p16f877.inc>        	; processor specific variable definitions
;
;**** Configuration festlegen *************************************************************
;	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _WRT_ENABLE_ON & _LVP_OFF & _DEBUG_ON & _CPD_OFF
;
;**** Konstanten festlegen ****************************************************************
;
; 	Ausgabe an Koppler zwischen PIC und KC
;
	#define OutKod	PORTB,3		; Ausgabe Datenwort
;
;	Anschlu PS/2 Tastatur an Port nach Wunsch A,B,C,D oder E
;
	#define	DATA PORTE,0
	#define	CLOCK PORTE,1
	#define	Tastatur PORTE
;
; 	fr Bank 0 und Bank 1
;
	#DEFINE BANK0 BCF 0x03,5			; Bank 0
	#DEFINE BANK1 BSF 0x03,5			; Bank 1	
;
;**** Variablennamen vergeben *************************************************************
;
      CBLOCK 0x20  					; Adresse wird angegeben geht bei 0x20 los
;      
 	FLAGTASTEBENE1					; Flagspeicher fr die Tastaturebene (SHIFT, SHIFT LOCK, NUM LOCK
 	FLAGTASTEBENE2					; Flagspeicher fr die Tastaturebene
	BYTE							; Speicherzelle fr Tastaturcode ( Auswertung )
	BYTE1							; Zwischenspeicherzelle fr Tastaturcode
	BYTE2							; Zwischenspeicherzelle fr Tastaturcode
      Quarz							; zur Einstellung der Zeitschleifen auf den verwendeten Quarz
      Temp							; 1.Ablage tempurre Bytes
      Temp1							; 2.Ablage tempurre Bytes      
      Loops							; Ablage Schleifendurchlauf     
      Loops1						; Ablage Schleifendurchlauf
      Loops2						; Ablage Schleifendurchlauf
      DatenBit                                  ; Ablage fr sequenzelles Bit	
	LEDANZEIGE						; Flagspeicher fr LED Anzeige der Tastatur	
      ParityBit						; Ablage fr Paritybit	
	safeW           					; w abspeichern	
	
	
	
	
	
;
	ENDC   						; Ende Adressverteiler
;
;******************************************************************************************
;* Programmstart													*
;******************************************************************************************
;
;------------------------------------------------------------------------------------------
;* BANK 0														*
;------------------------------------------------------------------------------------------
;
		ORG 0                   		; Reset Startadresse
PAGE0:
;
;******************************************************************************************
;* SET ANALOG/DIGITAL INPUTS											*
;******************************************************************************************
;
   		BANK1						; umschalten auf Speicherbank 1
		movlw 0x06
		movwf ADCON1        			; all digital
		movlw B'00000000' 			; Festlegen PORTA
		movwf TRISA					; bergabe an Speicherzelle TRISA fr PORTA                
		movlw B'00000000' 			; Festlegen PORTB 
		movwf TRISB					; bergabe an Speicherzelle TRISB fr PORTB               	
		movlw B'00000000' 			; Festlegen PORTC
     		movwf TRISC					; bergabe an Speicherzelle TRISB fr PORTC                
		movlw B'00000000' 			; Festlegen PORTD
		movwf TRISD					; bergabe an Speicherzelle TRISB fr PORTD
		movlw B'00000011' 			; Festlegen PORTE
		movwf TRISE					; bergabe an Speicherzelle TRISE fr PORTE
		BANK0						; Zurckschalten auf Speicherbank 0
;
;******************************************************************************************
;
;******************************************************************************************
;	Quarz einstellen ( Teiler vom PIC beachten externer Takt / 4 = interner Takt        *
;******************************************************************************************
;
;		movlw B'00010000'				; 4MHz
;		movlw B'00100000'				; 8MHz
;		movlw B'00110000'				; 12MHz
;		movlw B'01000000'				; 16MHz
 		movlw B'01010000'				; 20MHz
		movwf	Quarz					; zur Zeit auf 20MHz eingestellt
;
;******************************************************************************************
;	FLAGTASTEBENE1 und 2 lschen									      *
;******************************************************************************************
;
		clrf	FLAGTASTEBENE1			; <CLRF> Lsche die Speicherzelle <FLAGTASTEBENE1>
		clrf	FLAGTASTEBENE2			; <CLRF> Lsche die Speicherzelle <FLAGTASTEBENE2>
	     	clrf 	BYTE					; <CLRF> Lsche die Speicherzelle <BYTE>
           	clrf 	BYTE1					; <CLRF> Lsche die Speicherzelle <BYTE2>
            clrf 	BYTE2					; <CLRF> Lsche die Speicherzelle <BYTE2>
            clrf	LEDANZEIGE				; <CLRF> Lsche die Speicherzelle <ANZEIGE>
		bcf	OutKod
;
;******************************************************************************************
;	UP Tastatur auf Scan Code Set 3 setzen                           				*
;******************************************************************************************
;
		call	Wait
		call	Wait
		movlw B'11110000'					; F0 (Set Scan Code Set)
		movwf	DatenBit
		call	Parity
		call	PICzurTASTE					
		call 	ZEIT100s			
		movlw B'00000011'					; auf ScanCode 3 setzen
		movwf	DatenBit
		call	Parity				
		call	PICzurTASTE	
		call 	ZEIT100s
		call 	ZEIT100s
		call	Wait	
		movlw B'11101101'					; ED (Set/Reset LEDs)
		movwf	DatenBit
		call	Parity
		call	PICzurTASTE					
		call 	ZEIT100s
		movlw B'00000111'					; 3 LEDs  einschalten
		movwf	DatenBit
		call	Parity
		call	PICzurTASTE					
		call 	ZEIT100s
		call 	ZEIT100s
		call	Wait
		movlw B'11101101'					; ED (Set/Reset LEDs)
		movwf	DatenBit
		call	Parity
		call	PICzurTASTE					
		call 	ZEIT100s
		movlw B'00000000'					; 3 LED ausschalten
		movwf	DatenBit
		call	Parity
		call	PICzurTASTE					
		call 	ZEIT100s
		call 	ZEIT100s
		goto 	STARTTASTABF
;
;******************************************************************************************
; UP Parity Bit berechnen											*
;******************************************************************************************
;
Parity:							; Einsprung mit call Parity
		clrf	Temp1
		movwf	Temp	
		btfsc	Temp,0
		incf	Temp1,1
		btfsc	Temp,1
		incf	Temp1,1
		btfsc	Temp,2
		incf	Temp1,1
		btfsc	Temp,3
		incf	Temp1,1
		btfsc	Temp,4
		incf	Temp1,1
		btfsc	Temp,5
		incf	Temp1,1
		btfsc	Temp,6
		incf	Temp1,1
		btfsc	Temp,7
		incf	Temp1,1
		movf	Temp1,W
		xorlw 0x01
		btfsc	STATUS,Z	
		goto	Parset2
		movf	Temp1,W
		xorlw 0x03
		btfsc	STATUS,Z	
		goto	Parset2
		movf	Temp1,W
		xorlw 0x05
		btfsc	STATUS,Z	
		goto	Parset2	
		movf	Temp1,W
		xorlw 0x07
		btfsc	STATUS,Z	
		goto	Parset2
		bsf	ParityBit,0
		goto	Parset4
Parset2:
		bcf	ParityBit,0	
Parset4:
		return					; Rcksprung		
;		
;******************************************************************************************
; 	UP PIC sendet zur Tastatur										*
;******************************************************************************************
;
PICzurTASTE:			     			; Einsprung mit call PICzurTASTE
     		BANK1						; umschalten auf Speicherbank 1
     		movlw B'00000000' 	
     		movwf TRISE					; bergabe an Speicherzelle TRISE fr PORTE
     		BANK0						; umschalten auf Speicherbank 0
		bsf	DATA					; <PC ist beschftigt> deshalb DATA auf HI und CLOCK auf LOW
		bcf	CLOCK		
		call	ZEIT100s	
     		BANK1						; umschalten auf Speicherbank 1
      	movlw B'00000010' 			; Festlegen RE1 als Eingang <RE0 = PS2 Tastatur DATARE1 = PS2 Tastatur CLOCK>
      	movwf TRISE					; bergabe an Speicherzelle TRISB fr PORTC
     		BANK0						; umschalten auf Speicherbank 0
		bcf	DATA					; DATA auf LOW	
		call	ZEIT100s			
PzT3:
		btfsc CLOCK      	
		goto 	PzT3    				; gehe weiter wenn CLOCK low (0)
		btfss	DatenBit,0				; Datenbit 0
		bcf	DATA
		btfsc	DatenBit,0
		bsf	DATA
		call 	M95		
		btfss	DatenBit,1				; Datenbit 1
		bcf	DATA
		btfsc	DatenBit,1
		bsf	DATA
		call 	M95		
		btfss	DatenBit,2				; Datenbit 2
		bcf	DATA
		btfsc	DatenBit,2
		bsf	DATA
		call 	M95		
		btfss	DatenBit,3				; Datenbit 3
		bcf	DATA
		btfsc	DatenBit,3
		bsf	DATA
		call 	M95		
		btfss	DatenBit,4				; Datenbit 4
		bcf	DATA
		btfsc	DatenBit,4
		bsf	DATA
		call 	M95
		btfss	DatenBit,5				; Datenbit 5
		bcf	DATA
		btfsc	DatenBit,5
		bsf	DATA
		call 	M95
		btfss	DatenBit,6				; Datenbit 6
		bcf	DATA
		btfsc	DatenBit,6
		bsf	DATA
		call 	M95
		btfss	DatenBit,7				; Datenbit 7
		bcf	DATA
		btfsc	DatenBit,7
		bsf	DATA
		call 	M95
		btfss	ParityBit,0				; Datenbit Parity
		bcf	DATA
		btfsc	ParityBit,0
		bsf	DATA
		call 	M95
		bsf	DATA		
     		BANK1						; umschalten auf Speicherbank 1
     		movlw B'00000011' 			; Festlegen PORTE <RE0 = PS2 Tastatur DATARE1 = PS2 Tastatur CLOCK als Eingang>
     		movwf TRISE					; bergabe an Speicherzelle TRISE fr PORTE
     		BANK0						; umschalten auf Speicherbank 0
		call	ZEIT100s
		return
M95:
		btfss CLOCK					; gehe weiter wenn CLOCK high (1)
		goto M95					; gehe weiter wenn CLOCK low (0)
M96:
		btfsc CLOCK
		goto M96
		return					; Rcksprung
;
;******************************************************************************************	
;	UP WAIT Zeitschleife 											*
;******************************************************************************************
;
Wait:
top:
		movlw   .250 
        	movwf   Loops2
top2:	    
		NOP
        	NOP
        	NOP
        	NOP
        	NOP
        	NOP
        	NOP
        	decfsz  Loops2, F
        	goto    top2    
        	decfsz  Loops, F
        	goto    top
        	retlw   0
;
;******************************************************************************************		
; 	UP Zeitkonstante 100s											*
;******************************************************************************************
;
ZEIT100s:
		movf	Quarz,1
		movwf	Loops					; QUARZ * 10 / Quarz = 100 s
ZE1:
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		decfsz Loops,f
		goto ZE1
		return
;	        	
;******************************************************************************************
; 	UP Senden DatenBit zum Koppler 									*
;******************************************************************************************
;
SignalKC85:
;		movwf	DatenBit		; Bit6-0 = A,B,C,D,E,F
		call MICRO152
		BTFSS	DatenBit,7
		call MICRO5
		BTFSC	DatenBit,7
		call MICRO7		
; Bit A
		call MICRO152
		BTFSS	DatenBit,6
		call MICRO5
		BTFSC	DatenBit,6
		call MICRO7
; Bit B
		call MICRO152
		BTFSS	DatenBit,5
		call MICRO5
		BTFSC	DatenBit,5
		call MICRO7
; Bit C
		call MICRO152
		BTFSS	DatenBit,4
		call MICRO5
		BTFSC	DatenBit,4
		call MICRO7
; Bit D
		call MICRO152
		BTFSS	DatenBit,3
		call MICRO5
		BTFSC	DatenBit,3
		call MICRO7
; Bit E
		call MICRO152
		BTFSS	DatenBit,2
		call MICRO5
		BTFSC	DatenBit,2
		call MICRO7
; Bit F
		call MICRO152
		BTFSS	DatenBit,1
		call MICRO5
		BTFSC	DatenBit,1
		call MICRO7
; Wortabstand
		call	MICRO14
; Startbit 2 Wort
		call MICRO152
		BTFSS	DatenBit,7
		call MICRO5
		BTFSC	DatenBit,7
		call MICRO7		
; Bit A
		call MICRO152
		BTFSS	DatenBit,6
		call MICRO5
		BTFSC	DatenBit,6
		call MICRO7
; Bit B
		call MICRO152
		BTFSS	DatenBit,5
		call MICRO5			; 0 Bit
		BTFSC	DatenBit,5
		call MICRO7
; Bit C
		call MICRO152
		BTFSS	DatenBit,4
		call MICRO5			; 0 Bit
		BTFSC	DatenBit,4
		call MICRO7
; Bit D
		call MICRO152
		BTFSS	DatenBit,3
		call MICRO5			; 0 Bit
		BTFSC	DatenBit,3
		call MICRO7
; Bit E
		call MICRO152
		BTFSS	DatenBit,2
		call MICRO5			; 0 Bit
		BTFSC	DatenBit,2
		call MICRO7
; Bit F
		call MICRO152
		BTFSS	DatenBit,1
		call MICRO5			; 0 Bit
		BTFSC	DatenBit,1
		call MICRO7
 		call	MICRO14
;		goto	M9999
		movlw B'00000000'
		movwf	safeW           ;w abspeichern 
		movlw	HIGH (AUSGABERET)	;Highteil von tabelle holen
		movwf	PCLATH		;und nach PCLATH damit
		movlw	Low (AUSGABERET)	;Lowteil von Tabelle holen
		addwf	safeW,w		
		btfsc	STATUS,C	;berlauf?
		incf	PCLATH,f	;ja, um eins erhhen
		movwf	PCL		;Jump
		




;
;******************************************************************************************
; UP Schleife 2s mit call MICRO2										*
;******************************************************************************************
;
MICRO2:	
		NOP
		NOP
        	retlw   0              			; Rcksprung
;
;******************************************************************************************
; UP Schleife 28s mit call MICRO28										*
;******************************************************************************************
;
MICRO28:
		movlw	D'27'
		movwf	Loops	
M100:
		NOP
		NOP
		decfsz Loops,f
		goto 	M100
	      retlw   0              			; Rcksprung
;
;******************************************************************************************
; UP Schleife 4,968ms mit call MICRO5									*
;******************************************************************************************
;
MICRO5:
		movlw	D'32'
		movwf	Loops1
M101:
		movlw	D'193'
		movwf	Loops	
M102:
		NOP
		decfsz Loops,f
		goto 	M102
		decfsz Loops1,f
		goto 	M101
        	retlw   0              			; Rcksprung
;******************************************************************************************
; UP Schleife 6,988ms mit call MICRO7									*
;******************************************************************************************
;
MICRO7:
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		movlw	D'32'
		movwf	Loops1
M104:
		movlw	D'108'
		movwf	Loops	
M103:
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		decfsz Loops,f
		goto 	M103
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		decfsz Loops1,f
		goto 	M104
        	retlw   0              			; Rcksprung
;
;******************************************************************************************
; UP Wortabstand Schleife 14,34ms mit call MICRO14							*
;******************************************************************************************
;
MICRO14:
		call MICRO152
		movlw	D'30'
		movwf	Loops	
M107:
		NOP
		NOP
		NOP
		decfsz Loops,f
		goto 	M107
		movlw	D'48'
		movwf	Loops1
M105:
		movlw	D'245'
		movwf	Loops	
M106:
		NOP
		NOP
		NOP
		decfsz Loops,f
		goto 	M106
		decfsz	Loops1,f
		goto 	M105
        	retlw   0              			; Rcksprung
;
;******************************************************************************************
; UP Wortabstand Schleife 19,46ms mit call MICRO14							*
;******************************************************************************************
;
MICRO19:
		call MICRO152
		movlw	D'46'
		movwf	Loops	
M111:
		NOP
		NOP
		NOP
		decfsz Loops,f
		goto 	M111
M108:
		NOP
		NOP
		NOP
		decfsz Loops,f
		goto 	M108
		movlw	D'64'
		movwf	Loops1
M109:
		movlw	D'246'
		movwf	Loops	
M110:
		NOP
		NOP
		NOP
		decfsz Loops,f
		goto 	M110
		decfsz Loops1,f
		goto 	M109
        	retlw   0              			; Rcksprung
;
;******************************************************************************************
; UP Burst Schleife 152s mit call MICRO152								*
;******************************************************************************************
;
MICRO152:
		bsf	OutKod
		NOP
		call MICRO2
		NOP
		bcf	OutKod
		call MICRO28
		bsf	OutKod
		NOP
		call MICRO2
		NOP
		bcf	OutKod
		call MICRO28
		bsf	OutKod
		NOP
		call MICRO2
		NOP
		bcf	OutKod
		call MICRO28
		bsf	OutKod
		NOP
		call MICRO2
		NOP
		bcf	OutKod
		call MICRO28
		bsf	OutKod
		NOP
		call MICRO2
		NOP
		bcf	OutKod
		call MICRO28
		bsf	OutKod
		NOP
		call MICRO2
		NOP
		bcf	OutKod
		retlw   0              			; Rcksprung

;
;******************************************************************************************
;* UP LED ANZEIGE						                                          *			
;******************************************************************************************
;
LEDTAST:
		movlw B'11101101'
		movwf	DatenBit	
		call	Parity
		call	PICzurTASTE					
		call 	ZEIT100s
		movf 	LEDANZEIGE,W
		movwf	DatenBit 	
		call	Parity
		call	PICzurTASTE					
		call Wait
;		goto	ENDE
		
		
		movlw B'00000000'
		movwf	safeW           ;w abspeichern 
		movlw	HIGH (LEDRET)	;Highteil von tabelle holen
		movwf	PCLATH		;und nach PCLATH damit
		movlw	Low (LEDRET)	;Lowteil von Tabelle holen
		addwf	safeW,w		
		btfsc	STATUS,C	;berlauf?
		incf	PCLATH,f	;ja, um eins erhhen
		movwf	PCL		;Jump
		goto	M9999


;
;******************************************************************************************
;
;******************************************************************************************
;* MODUL - ABFRAGE EINER PS/2-TASTATUR  / ANFANG                                          *			
;******************************************************************************************
; Tastaturabfrage ber die Eingnge DATA und CLOCK				  			*
; bei angeschlossnener Tastatur sind DATA und CLK auf Hi ist keine Tastatur angeschlossen	*
; bleibt das Programm in der Schleife <STARTTASTABF> stecken					*
;******************************************************************************************
;
;* < ANFANG SCHLEIFE **********************************************************************
		
STARTTASTABF	comf 	Tastatur,W		; COMF eine Speicherzelle invertieren
							; (Complement bilden)
							; 8 Bit 00000000 = 00
							; invertieren
							; 8 Bit 11111111 = FF
							; oder  00000011 = 03
							; invertieren
							; 11111100 = FC
		
                	andlw B'00000011'		; <ANDLW> W und eine Zahl mit
							; der UND-Funktion verknpfen 
							; 8 Bit 11111100 = FC mit dem Arbeitsreg. <W>
							; UND verknpfen
							; 8 Bit 00000011 = 03 ergibt
							; 8 Bit 00000000 = 00 Z Flag gesetzt 0
                	btfsc STATUS,Z		; BTFSC bergehe nachfolgenden Befehl
							; wenn Z Flag = 0 ist
                	goto 	STARTTASTABF
;
;* < ENDE SCHLEIFE ************************************************************************
;
                	call EMPFANG1      	; beide Eingnge auf Hi
							; springe zu <EMPFANG1> und komme zurck
;
;******************************************************************************************
;* ab hier kann die Auswertung des Tastaturcodes der in <BYTE> steht beginnen			*
;******************************************************************************************
;




	movwf	safeW           ;w abspeichern 
	movlw	HIGH (M0002)	;Highteil von tabelle holen
	movwf	PCLATH		;und nach PCLATH damit
	movlw	Low (M0002)	;Lowteil von Tabelle holen
	addwf	safeW,w		
	btfsc	STATUS,C	;berlauf?
	incf	PCLATH,f	;ja, um eins erhhen
	movwf	PCL		;Jump


M0001:
			call SignalKC85	













M9999:
;		
;******************************************************************************************
; Lschen der Speicherzellen											*
;******************************************************************************************
;
	     	clrf 	BYTE					; <CLRF> Lsche die Speicherzelle <BYTE>
           	clrf 	BYTE1					; <CLRF> Lsche die Speicherzelle <BYTE2>
            clrf 	BYTE2					; <CLRF> Lsche die Speicherzelle <BYTE2>
   			     		
     		goto 	STARTTASTABF			; neue Tastaturabfrage	
;
;******************************************************************************************
;* ab hier kann die Auswertung des Tastaturcodes der in <BYTE> steht beginnen	/ ENDE	*
;******************************************************************************************
;
;******************************************************************************************
;* Unterprogramm ABFRAGE DER TASTATUR  /  ANFANG							*
;******************************************************************************************

; Schema Taktgeber und Datenleitung
;         
;       - - -   -   -   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   -   -   -
;       - -     - - - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           - - - - - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd
;
; S (Startbit) = immer 0
; 8 Informationsbit
; Paritbit
; W (Endbit) = immer 1
; x hier erfolgt jeweils das Auslesen



EMPFANG1:

   		BANK1						; umschalten auf Speicherbank 1
  	   	movlw B'00000011' 			; Festlegen PORTE <RE0 = PS2 Tastatur DATARE1 = PS2 Tastatur CLOCK als Eingang>
  	   	movwf TRISE					; bergabe an Speicherzelle TRISE fr PORTE
   		BANK0						; umschalten auf Speicherbank 0



;         
;       - - x   -   -   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   -   -   -
;       - -     - - - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           x - - - - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd
; CLOCK 1 1 1
; DATA  1 1 0


LOS			btfsc	CLOCK 
			btfsc	DATA 
			goto	LOS



;* < ABFRAGE START-BIT ********************************************************************

;* 	< ABFRAGE EINGANG RA0 *************************************************************
;         
;       - - -   -   -   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             x   -   -   -   -   -   -   -   -   -   -
;       - -     - - - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           - x - - - - - - - - - - - - - - - - - - -  
;               LSB                          MSB Odd
; CLOCK       0
; DATA        0


KABEL1		btfss	CLOCK 
			btfsc	DATA 
			goto	KABEL1			
			btfsc	DATA 			; Startbit auswerten (immer 0)
			return			; Startbit nicht 0

;* 	> ENDE ABFRAGE EINGANG RA0 *********************************************************	

;* > ENDE ABFRAGE START-BIT **************************************************************

;* < ABFRAGE BIT0 ************************************************************************
;         
;       - - -   H   -   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             -   L   -   -   -   -   -   -   -   -   -
;       - -     - x - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           - - - x - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd   

			call 	HIGHLOW              	
 			btfss	DATA 
			bcf	BYTE1,0
			btfsc	DATA 
			bsf	BYTE1,0
               	
;* > ENDE ABFRAGE BIT0 ********************************************************************


;* < ABFRAGE BIT1 *************************************************************************
;         
;       - - -   -   H   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   L   -   -   -   -   -   -   -   -
;       - -     - - - x - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - x - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd
 
			call 	HIGHLOW
			btfss	DATA 
			bcf	BYTE1,1
			btfsc	DATA 
			bsf	BYTE1,1
			
;* > ENDE ABFRAGE BIT1 ********************************************************************


;* < ABFRAGE BIT2 *************************************************************************
;         
;       - - -   -   -   H   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             -   -   -   L   -   -   -   -   -   -   -
;       - -     - - - - - x - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           - - - - - - - x - - - - - - - - - - - - -  
;                LSB                         MSB Odd

			call 	HIGHLOW 
			btfss	DATA 
			bcf	BYTE1,2
			btfsc	DATA 
			bsf	BYTE1,2

;* > ENDE ABFRAGE BIT2 ********************************************************************


;* < ABFRAGE BIT3 *************************************************************************
;         
;       - - -   -   -   -   H   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   L   -   -   -   -   -   -
;       - -     - - - - - - - x - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - x - - - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA 
			bcf	BYTE1,3
			btfsc	DATA 
			bsf	BYTE1,3

;* > ENDE ABFRAGE BIT3 ********************************************************************

;* < ABFRAGE BIT4 *************************************************************************
;         
;       - - -   -   -   -   -   H   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             -   -   -   -   -   L   -   -   -   -   -
;       - -     - - - - - - - - - x - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - x - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
 			btfss	DATA 
			bcf	BYTE1,4
			btfsc	DATA 
			bsf 	BYTE1,4

;* > ENDE ABFRAGE BIT4 ********************************************************************


;* < ABFRAGE BIT5 *************************************************************************
;         
;       - - -   -   -   -   -   -   H   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   L   -   -   -   -
;       - -     - - - - - - - - - - - x - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           - - - - - - - - - - - - - x - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
 			btfss	DATA 
			bcf	BYTE1,5
			btfsc	DATA 
			bsf	BYTE1,5

;* > ENDE ABFRAGE BIT5 ********************************************************************

;* < ABFRAGE BIT6 *************************************************************************
;         
;       - - -   -   -   -   -   -   -   H   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   L   -   -   -
;       - -     - - - - - - - - - - - - - x - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - x - - - - -  
;                LSB                         MSB Odd

			call 	HIGHLOW
 			btfss	DATA 
			bcf	BYTE1,6
			btfsc	DATA 
			bsf	BYTE1,6

;* > ENDE ABFRAGE BIT6 ********************************************************************

;* < ABFRAGE BIT7 *************************************************************************
;         
;       - - -   -   -   -   -   -   -   -   H   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   L   -   -
;       - -     - - - - - - - - - - - - - - - x - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - - - x - - -  
;                LSB                         MSB Odd

			call 	HIGHLOW
 			btfss	DATA 
			bcf	BYTE1,7
			btfsc	DATA 
			bsf	BYTE1,7

;* > ENDE ABFRAGE BIT7 ********************************************************************

;* < ABFRAGE Paritt-Bit ******************************************************************
;         
;       - - -   -   -   -   -   -   -   -   -   H   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   -   L   -
;       - -     - - - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW	; Paritt_Bit


;* > ENDE ABFRAGE Parity-Bit **************************************************************

;* < ABFRAGE STOP-Bit *********************************************************************
;         
;       - - -   -   -   -   -   -   -   -   -   -   H   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   -   -   L
;       - -     - - - - - - - - - - - - - - - - - - - x - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd
 
			call HIGHLOW 	; STOP_Bit



;* > ENDE ABFRAGE STOP-Bit ****************************************************************


;*  < ABFRAGE der Speicherzelle <BYTE1> auf folgende Bytes 0xF0  **************************
;* 	< ABFRAGE SPEICHERZELLE <BYTE1> auf BYTE 0xF0

                	movf BYTE1,W 	; <MOVF> Kopiere den Inhalt der Speicherzelle
						; <BYTE1> ins Arbeitsregister <W> 
     
                	xorlw 0xF0		; <XORLW> W und eine Zahl mit der
						; Exclusiv-ODER-Funktion verknpfen

                	btfsc STATUS,Z	; <BTFSs> bergehe nachfolgenden Befehl,
						; wenn Bit=1  (bit test f, skip if clear) 

                	goto EMPFANG2	; ja also zweites Byte erhalten      	
						; yes, so get second byte

;* 	< ENDE ABFRAGE SPEICHERZELLE <BYTE1> auf BYTE 0xF0

                	movf 	BYTE1,W
               	movwf BYTE

                	
   			BANK1						; umschalten auf Speicherbank 1	
      		movlw B'00000000' 		
     			movwf TRISE						; bergabe an Speicherzelle TRISE fr PORTE
    			BANK0						; umschalten auf Speicherbank 0

			bsf	DATA						; <PC ist beschftigt> deshalb DATA auf HI und CLOCK auf LOW
			bcf	CLOCK
                         	                	
                	return		; in <BYTE> steht der Tastaturcode

; * < ENDE ABFRAGE der Speicherzelle <BYTE1> auf folgende Bytes 0xF0, 0xE1, 0xE0 **********

EMPFANG2				; 2.Durchlauf zur Ermittlung des 2. BYTES

		; 1 Startbit  (immer 0)
		; 8 Databits  (00-FF)
		; 1 Paritybit (ungerade)
		; 1 Stopbit   (immer 1)
;         
;       - - x   -   -   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             -   -   -   -   -   -   -   -   -   -   -
;       - -     - - - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           x - - - - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd
; CLOCK 1 1 1
; DATA  1 1 0

LOS1			btfsc	CLOCK 
			btfsc	DATA 
			goto	LOS1



;* < ABFRAGE START-BIT ********************************************************************

;* 	< ABFRAGE EINGANG RA0 *************************************************************
;         
;       - - -   -   -   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             x   -   -   -   -   -   -   -   -   -   -
;       - -     - - - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           - x - - - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd
; CLOCK       0
; DATA        0

KABEL2		btfss	CLOCK 
			btfsc	DATA 
			goto	KABEL2			
			btfsc	DATA 			; Startbit auswerten (immer 0)
			return			; Startbit nicht 0

;* 	> ENDE ABFRAGE EINGANG RA0 ********************************************************

;* > ENDE ABFRAGE START-BIT ***************************************************************


;* < ABFRAGE BIT0 *************************************************************************
;         
;       - - -   H   -   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   L   -   -   -   -   -   -   -   -   -
;       - -     - x - - - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E 
;           - - - x - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd
   
               	call HIGHLOW 
			btfss	DATA 
			bcf	BYTE2,0
			btfsc	DATA 
			bsf	BYTE2,0

;* > ENDE ABFRAGE BIT0 ********************************************************************


;* < ABFRAGE BIT1 *************************************************************************
;         
;       - - -   -   H   -   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             -   -   L   -   -   -   -   -   -   -   -
;       - -     - - - x - - - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - x - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA 
			bcf	BYTE2,1
			btfsc	DATA 
			bsf	BYTE2,1

;* > ENDE ABFRAGE BIT1 ********************************************************************


;* < ABFRAGE BIT2 *************************************************************************
;         
;       - - -   -   -   H   -   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / 
;             -   -   -   L   -   -   -   -   -   -   -
;       - -     - - - - - x - - - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - x - - - - - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA 
			bcf	BYTE2,2
			btfsc	DATA 
			bsf	BYTE2,2

;* > ENDE ABFRAGE BIT2 ********************************************************************


;* < ABFRAGE BIT3 *************************************************************************
;         
;       - - -   -   -   -   H   -   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   L   -   -   -   -   -   -
;       - -     - - - - - - - x - - - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - x - - - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA 
			bcf	BYTE2,3
			btfsc	DATA 
			bsf	BYTE2,3

;* > ENDE ABFRAGE BIT3 ********************************************************************

;* < ABFRAGE BIT4 *************************************************************************
;         
;       - - -   -   -   -   -   H   -   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   L   -   -   -   -   -
;       - -     - - - - - - - - - x - - - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - x - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA 
			bcf	BYTE2,4
			btfsc	DATA 
			bsf	BYTE2,4

;* > ENDE ABFRAGE BIT4 ********************************************************************


;* < ABFRAGE BIT5 *************************************************************************
;         
;       - - -   -   -   -   -   -   H   -   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   L   -   -   -   -
;       - -     - - - - - - - - - - - x - - - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - x - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA
			bcf	BYTE2,5
			btfsc	DATA
			bsf	BYTE2,5

;* > ENDE ABFRAGE BIT5 ********************************************************************

;* < ABFRAGE BIT6 *************************************************************************
;         
;       - - -   -   -   -   -   -   -   H   -   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   L   -   -   -
;       - -     - - - - - - - - - - - - - x - - - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - x - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA
			bcf	BYTE2,6
			btfsc	DATA
			bsf	BYTE2,6

;* > ENDE ABFRAGE BIT6 ********************************************************************

;* < ABFRAGE BIT7 *************************************************************************
;         
;       - - -   -   -   -   -   -   -   -   H   -   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   L   -   -
;       - -     - - - - - - - - - - - - - - - x - - - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - - - x - - -  
;                LSB                         MSB Odd

			call HIGHLOW
			btfss	DATA
			bcf	BYTE2,7
			btfsc	DATA
			bsf	BYTE2,7

;* > ENDE ABFRAGE BIT7 ********************************************************************

;* < ABFRAGE Parity-Bit *******************************************************************
;         
;       - - -   -   -   -   -   -   -   -   -   H   -   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   -   L   -
;       - -     - - - - - - - - - - - - - - - - - x - - - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - - - - - x -  
;                LSB                         MSB Odd

			call HIGHLOW	; Parity_Bit

;* > ENDE ABFRAGE Parity-Bit **************************************************************

;* < ABFRAGE STOP-Bit *********************************************************************
;         
;       - - -   -   -   -   -   -   -   -   -   -   H   - - -
; CLOCK      \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
;             -   -   -   -   -   -   -   -   -   -   L
;       - -     - - - - - - - - - - - - - - - - - - - x - - -
; DATA     \  S | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | P | E
;           - - - - - - - - - - - - - - - - - - - - -  
;                LSB                         MSB Odd

			call HIGHLOW	; STOP_Bit

;* > ENDE ABFRAGE STOP-Bit ****************************************************************

           	movf 	BYTE2,W
           	movwf BYTE
           	
           	
    		BANK1						; umschalten auf Speicherbank 1    		
     		movlw B'00000000' 		
     		movwf TRISE						; bergabe an Speicherzelle TRISE fr PORTE
   		BANK0						; umschalten auf Speicherbank 1

		bsf	DATA						; <PC ist beschftigt> deshalb DATA auf HI und CLOCK auf LOW
		bcf	CLOCK

		return		; in <BYTE> steht der Tastaturcode
;
;******************************************************************************************
;* MODUL - ABFRAGE EINER PS/2-TASTATUR  / ENDE                                            *
;******************************************************************************************
;	UP HIGHLOW													*
;******************************************************************************************
;
HIGHLOW:
		btfss CLOCK					; gehe weiter wenn CLOCK high (1)
		goto HIGHLOW				; gehe weiter wenn CLOCK low (0)
HL2:
		btfsc CLOCK
		goto HL2
		return					; Rcksprung
;
;******************************************************************************************
;
;------------------------------------------------------------------------------------------
;* BANK 1														*
;------------------------------------------------------------------------------------------
;
		ORG 0x800
PAGE1:
;

;
;******************************************************************************************
;* ab hier kann die Auswertung des Tastaturcodes der in <BYTE> steht beginnen			*
;******************************************************************************************
;
; FLAGTASTEBENE1	BIT   7 6 5 4 3 2 1 0
;				| | | | | | | |
;				| | | | | | | -- Caps Lock 	14
;                       | | | | | | ---- L Shift 	12 R Shift mit auf Bit 1 gelegt
;				| | | | | ------ R Shift 	59
;				| | | | -------- L CTRL		11
;				| | | ---------- R CTRL		58
;				| | ------------ L ALT		19 fr @(Q)  |(><)  ~(+*) 
;				| -------------- R ALT 		39 wird nicht benutzt
;				---------------- NUM Lock	76
;
; FLAGTASTEBENE2	BIT   7 6 5 4 3 2 1 0
;				| | | | | | | |
;				| | | | | | | -- Scroll Lock	5F
;                       | | | | | | ---- L Win		8B
;				| | | | | ------ R Win		8C
;				| | | | -------- TPKC an/aus	( noch nicht bearbeitet )
;				| | | ---------- frei
;				| | ------------ frei
;				| -------------- frei 
;				---------------- Gro-kleinschreibung
;
;******************************************************************************************
; Auswertung CAPS Lock und Shift zur Gro-Kleinschreibung						*
; FLAGTASTEBENE2 BIT 7												*
;******************************************************************************************
;
M0002:
;
;******************************************************************************************
; Auswertung CAPS Lock und Shift zur Gro-Kleinschreibung						*
; FLAGTASTEBENE2 BIT 7												*
;******************************************************************************************
;
		btfss	FLAGTASTEBENE1,0
		goto 	M400
		btfss	FLAGTASTEBENE1,1
		goto	M405
		goto  M406		
M400:		
		btfss	FLAGTASTEBENE1,1		
		goto	M406
		goto  M405     
M405:
		bsf 	FLAGTASTEBENE2,7			; Groschreiben	
		goto	M407
M406:		
		bcf 	FLAGTASTEBENE2,7			; Kleinschreibung
M407:
;
;******************************************************************************************
; MAKECODE ( Taste gedrckt ) bzw. BREACODE ( Taste wieder losgelassen ) auswerten		*
;******************************************************************************************
		
		movf 	BYTE1,W 
		xorlw 0xF0					; berprfen BREAKCODE F0
		btfss STATUS,Z
		goto	M1100					; MAKECODE abfragen
;
;******************************************************************************************
; BREAKCODE  ( Taste wieder losgelassen ) auswerten							*
;******************************************************************************************
;		
		movf 	BYTE,W 
		xorlw 0x14					; berprfen BREAKCODE 14 CAPS
		btfsc STATUS,Z
		goto	ENDE		

		movf 	BYTE,W 
		xorlw 0x12					; berprfen BREAKCODE 12 L Shift
		btfsc STATUS,Z
		goto	M1000
		
		movf 	BYTE,W 
		xorlw 0x59					; berprfen BREAKCODE 59 R Shift
		btfsc STATUS,Z
		goto	M1001

		movf 	BYTE,W 
		xorlw 0x11					; berprfen BREAKCODE 11 L CTRL
		btfsc STATUS,Z
		goto	M1002

		movf 	BYTE,W 
		xorlw 0x58					; berprfen BREAKCODE 58 R CTRL
		btfsc STATUS,Z
		goto	M1003

		
		movf 	BYTE,W 
		xorlw 0x19					; berprfen BREAKCODE 19 L ALT
		btfsc STATUS,Z
		goto	M1004

		movf 	BYTE,W 
		xorlw 0x39					; berprfen BREAKCODE 39 R ALT
		btfsc STATUS,Z
		goto	M1005

		movf 	BYTE,W 
		xorlw 0x76					; berprfen BREAKCODE 76 NUM LOCK
		btfsc STATUS,Z
		goto	M1006

		movf 	BYTE,W 
		xorlw 0x5F					; berprfen BREAKCODE 5F SCROLL LOCK
		btfsc STATUS,Z
		goto	M1007


		movf 	BYTE,W 
		xorlw 0x8B					; berprfen BREAKCODE 8B L Win
		btfsc STATUS,Z
		goto	M1008

		movf 	BYTE,W 
		xorlw 0x8C					; berprfen BREAKCODE 8C R Win
		btfsc STATUS,Z
		goto	M1009

		goto 	ENDE
;
;
;******************************************************************************************
; BREAKCODE  12 L Shift ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1000:							; berprfen BREAKCODE 12 L Shift	
		bcf	FLAGTASTEBENE1,1
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  59 R Shift ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1001:							; berprfen BREAKCODE 59 R Shift
		
		bcf	FLAGTASTEBENE1,1
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  11 L CTRL ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1002:							; berprfen BREAKCODE 11 L CTRL
		btfss FLAGTASTEBENE1,0
		goto 	M202		
		bcf	FLAGTASTEBENE1,3
;		bcf	LEDANZEIGE,1
;		goto 	LED
		goto	ENDE
M202:
		bsf	FLAGTASTEBENE1,3
;		bcf	LEDANZEIGE,1
;		goto 	LED
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  58 R CTRL ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1003:							; berprfen BREAKCODE 58 R CTRL
		btfss FLAGTASTEBENE1,0
		goto 	M203		
		bcf	FLAGTASTEBENE1,4
;		bcf	LEDANZEIGE,1
;		goto 	LED
		goto	ENDE
M203:
		bsf	FLAGTASTEBENE1,4
;		bcf	LEDANZEIGE,1
;		goto 	LED
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  19 L ALT ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1004:							; berprfen BREAKCODE 19 L ALT
		bcf	FLAGTASTEBENE1,5
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  39 R ALT ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1005:							; berprfen BREAKCODE 39 R ALT
;		bcf	FLAGTASTEBENE1,6
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  76 NUM LOCK ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1006:							; berprfen BREAKCODE 76 NUM LOCK
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  5F SCROLL LOCK ( Taste gedrckt ) auswerten						*
;******************************************************************************************
;
M1007:							; berprfen BREAKCODE 5F SCROLL LOCK
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  8B L Win ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1008:							; berprfen BREAKCODE 8B L Win
		bcf	FLAGTASTEBENE2,1
		goto 	ENDE
;
;******************************************************************************************
; BREAKCODE  8C R Win ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1009:							; berprfen BREAKCODE 8C R Win
		bcf	FLAGTASTEBENE2,2
		goto 	ENDE
;
;******************************************************************************************
; MAKECODE  ( Taste gedrckt ) auswerten									*
;******************************************************************************************
;		
M1100:				
		movf 	BYTE,W 
		xorlw 0x14					; berprfen MAKECODE 14 CAPS
		btfsc STATUS,Z
		goto	M1101

		movf 	BYTE,W 
		xorlw 0x12					; berprfen MAKECODE 12 L Shift
		btfsc STATUS,Z
		goto	M1102
		
		movf 	BYTE,W 
		xorlw 0x59					; berprfen MAKECODE 59 R Shift
		btfsc STATUS,Z
		goto	M1103

		movf 	BYTE,W 
		xorlw 0x11					; berprfen MAKECODE 11 L CTRL
		btfsc STATUS,Z
		goto	M1104

		movf 	BYTE,W 
		xorlw 0x58					; berprfen MAKECODE 58 R CTRL
		btfsc STATUS,Z
		goto	M1105

		
		movf 	BYTE,W 
		xorlw 0x19					; berprfen MAKECODE 19 L ALT
		btfsc STATUS,Z
		goto	M1106

		movf 	BYTE,W 
		xorlw 0x39					; berprfen MAKECODE 39 R ALT
		btfsc STATUS,Z
		goto	M1107

		movf 	BYTE,W 
		xorlw 0x76					; berprfen MAKECODE 76 NUM LOCK
		btfsc STATUS,Z
		goto	M1108

		movf 	BYTE,W 
		xorlw 0x5F					; berprfen MAKECODE 5F SCROLL LOCK
		btfsc STATUS,Z
		goto	M1109


		movf 	BYTE,W 
		xorlw 0x8B					; berprfen MAKECODE 8B L Win
		btfsc STATUS,Z
		goto	M1110

		movf 	BYTE,W 
		xorlw 0x8C					; berprfen MAKECODE 8C R Win
		btfsc STATUS,Z
		goto	M1111

		goto 	M3000
;
;******************************************************************************************
; MAKECODE  14 CAPS ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;		
M1101:							; berprfen MAKECODE 14 CAPS
		btfss FLAGTASTEBENE1,0
		goto 	M300		
		bcf	FLAGTASTEBENE1,0
		movlw	B'11001110'
		movwf	DatenBit
 		call	AUSGABE
 		bcf	LEDANZEIGE,2
 		call 	LED
		goto	ENDE
M300:
		bsf	FLAGTASTEBENE1,0
		movlw	B'11001110'
 		movwf	DatenBit
 		call	AUSGABE
 		bsf	LEDANZEIGE,2
 		call 	LED
		goto  ENDE
;
;******************************************************************************************
; MAKECODE  12 L Shift ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;		
M1102:							; berprfen MAKECODE 12 L Shift	
		bsf	FLAGTASTEBENE1,1
		goto	ENDE
;
;******************************************************************************************
; MAKECODE  59 R Shift ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1103:							; berprfen MAKECODE 59 R Shift	
		bsf	FLAGTASTEBENE1,1
		goto	ENDE
;
;******************************************************************************************
; MAKECODE  11 L CTRL ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1104:							; berprfen MAKECODE 11 L CTRL
		btfss FLAGTASTEBENE1,0
		goto 	M303		
		bcf	FLAGTASTEBENE1,3
;		bsf	LEDANZEIGE,1
;		goto 	LED
		goto	ENDE
M303:
		bsf	FLAGTASTEBENE1,3
;		bsf	LEDANZEIGE,1
;		goto 	LED
		goto 	ENDE
;
;******************************************************************************************
; MAKECODE  58 R CTRL ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1105:							; berprfen MAKECODE 58 R CTRL
		btfss FLAGTASTEBENE1,0
		goto 	M304		
		bcf	FLAGTASTEBENE1,4
;		bsf	LEDANZEIGE,1
;		goto 	LED
		goto	ENDE
M304:
		bsf	FLAGTASTEBENE1,4
;		bsf	LEDANZEIGE,1
;		goto 	LED
		goto 	ENDE
;
;******************************************************************************************
; MAKECODE  19 L ALT ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1106:							; berprfen MAKECODE 19 L ALT
		bsf	FLAGTASTEBENE1,5
		goto 	ENDE
;
;******************************************************************************************
; MAKECODE  39 R ALT ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1107:							; berprfen MAKECODE 39 R ALT
;		bsf	FLAGTASTEBENE1,6
		goto 	ENDE
;
;******************************************************************************************
; MAKECODE  59 NUM LOCK ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1108:							; berprfen MAKECODE 76 NUM LOCK
		btfss FLAGTASTEBENE1,7
		goto 	M307		
		bcf	FLAGTASTEBENE1,7
		bcf	LEDANZEIGE,1
 		call 	LED
		goto  ENDE
M307:
		bsf	FLAGTASTEBENE1,7
		bsf	LEDANZEIGE,1
 		call 	LED
		goto  ENDE
;
;******************************************************************************************
; MAKECODE  5F SCROLL LOCK ( Taste gedrckt ) auswerten						*
;******************************************************************************************
;
M1109:							; berprfen MAKECODE 5F SCROLL LOCK
		btfss FLAGTASTEBENE2,0
		goto 	M308		
		bcf	FLAGTASTEBENE2,0
		bcf	LEDANZEIGE,0
 		call 	LED
		goto  ENDE
M308:
		bsf	FLAGTASTEBENE2,0
		bsf	LEDANZEIGE,0
 		call 	LED
		goto  ENDE
;
;******************************************************************************************
; MAKECODE  8B L Win ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1110:							; berprfen MAKECODE 8B L Win
		bsf	FLAGTASTEBENE2,1		
		goto 	ENDE
;
;******************************************************************************************
; MAKECODE  8C R Win ( Taste gedrckt ) auswerten							*
;******************************************************************************************
;
M1111:							; berprfen MAKECODE 8C R Win
		bsf	FLAGTASTEBENE2,2
		goto 	ENDE
;		
;******************************************************************************************
;
;
;******************************************************************************************
; Auswertung Tasten mit Caps Lock, Shift L u R								*
;******************************************************************************************
;
M3000:	
	movf 	BYTE,W 
	xorlw 0x08					; berprfen MAKECODE 08 ESC = CLR / HCOPY
	btfss STATUS,Z
	goto  M3001
	btfss FLAGTASTEBENE2,7
	movlw	B'10011000'				; CLR
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00011000'				; HCOPY
	call	AUSGABE
	goto	ENDE
M3001:
	movf 	BYTE,W 
	xorlw 0x07					; berprfen MAKECODE 07 F1 = F1 / F1
	btfss STATUS,Z
	goto  M3002
	btfss FLAGTASTEBENE1,0
	goto  M356
	btfss	FLAGTASTEBENE2,7			
	movlw	B'00111110'				; F1
	btfsc FLAGTASTEBENE2,7
	movlw	B'00111110'				; F1
	call	AUSGABE
	goto	ENDE	
M356:	
	btfss FLAGTASTEBENE2,7
	movlw	B'10111110'				; F1
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10111110'				; F1
	call	AUSGABE
	goto	ENDE
M3002:
	movf 	BYTE,W 
	xorlw 0x0F					; berprfen MAKECODE 0F F2 = F2 / F2
	btfss STATUS,Z
	goto  M3003
	btfss FLAGTASTEBENE1,0
	goto  M357
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00110000'				; F2
	btfsc FLAGTASTEBENE2,7
	movlw	B'00110000'				; F2	
	call	AUSGABE
	goto	ENDE
M357:	
	btfss FLAGTASTEBENE2,7
	movlw	B'10110000'				; F2
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10110000'				; F2
	movwf	DatenBit
	call	AUSGABE
	goto	ENDE
M3003:
	movf 	BYTE,W 
	xorlw 0x17					; berprfen MAKECODE 17 F3 = F3 / F3
	btfss STATUS,Z
	goto  M3004
	btfss FLAGTASTEBENE1,0
	goto  M358
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00111000'				; F3
	btfsc FLAGTASTEBENE2,7
	movlw	B'00111000'				; F3
	call	AUSGABE
	goto	ENDE
M358:	
	btfss FLAGTASTEBENE2,7
	movlw	B'10111000'				; F3
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10111000'				; F3
	call	AUSGABE
	goto	ENDE
M3004:
	movf 	BYTE,W 
	xorlw 0x1F					; berprfen MAKECODE 1F F4 = F4 / F4
	btfss STATUS,Z
	goto  M3005
	btfss FLAGTASTEBENE1,0
	goto  M359
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00110110'				; F4
	btfsc FLAGTASTEBENE2,7
	movlw	B'00110110'				; F4
	call	AUSGABE
	goto	ENDE	
M359:	
	btfss FLAGTASTEBENE2,7
	movlw	B'10110110'				; F4
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'10110110'				; F4
	call	AUSGABE
	goto	ENDE
M3005:
	movf 	BYTE,W 
	xorlw 0x27					; berprfen MAKECODE 27 F5 = F5 / F5
	btfss STATUS,Z
	goto  M3006
	btfss FLAGTASTEBENE1,0
	goto  M360
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00110100'				; F5
	btfsc FLAGTASTEBENE2,7
	movlw	B'00110100'				; F5
	call	AUSGABE
	goto	ENDE	
M360:	
	btfss FLAGTASTEBENE2,7
	movlw	B'10110100'				; F5
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'10110100'				; F5
	call	AUSGABE
	goto	ENDE
	
M3006:
	movf 	BYTE,W 
	xorlw 0x2F					; berprfen MAKECODE 2F F6 = F6 / F6
	btfss STATUS,Z
	goto  M3007
	btfss FLAGTASTEBENE1,0
	goto  M361
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00111010'				; F6
	btfsc FLAGTASTEBENE2,7
	movlw	B'00111010'				; F6
	call	AUSGABE
	goto	ENDE	
M361:	
	btfss FLAGTASTEBENE2,7
	movlw	B'10111010'				; F6
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'10111010'				; F6
	call	AUSGABE
	goto	ENDE
M3007:
	movf 	BYTE,W 
	xorlw 0x37					; berprfen MAKECODE 37 F7 = F7 / F7
	btfss STATUS,Z
	goto  M3008
	btfss FLAGTASTEBENE1,0
	goto  M362
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10111110'				; F7
	btfsc FLAGTASTEBENE2,7
	movlw	B'10111110'				; F7
	call	AUSGABE
	goto	ENDE	
M362:	
	btfss FLAGTASTEBENE2,7
	movlw	B'00111110'				; F7
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00111110'				; F7
	call	AUSGABE
	goto	ENDE
M3008:
	movf 	BYTE,W 
	xorlw 0x3F					; berprfen MAKECODE 3F F8 = F8 / F8
	btfss STATUS,Z
	goto  M3009
	btfss FLAGTASTEBENE1,0
	goto  M364
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10110000'				; F8
	btfsc FLAGTASTEBENE2,7
	movlw	B'10110000'				; F8
	call	AUSGABE
	goto	ENDE	
M364:	
	btfss FLAGTASTEBENE2,7
	movlw	B'00110000'				; F8
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00110000'				; F8
	call	AUSGABE
	goto	ENDE
M3009:
	movf 	BYTE,W 
	xorlw 0x47					; berprfen MAKECODE 47 F9 = F9 / F9
	btfss STATUS,Z
	goto  M3010
	btfss FLAGTASTEBENE1,0
	goto  M365
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10111000'				; F9
	btfsc FLAGTASTEBENE2,7
	movlw	B'10111000'				; F9
	call	AUSGABE
	goto	ENDE	
M365:	
	btfss FLAGTASTEBENE2,7
	movlw	B'00111000'				; F9
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00111000'				; F9
	call	AUSGABE
	goto	ENDE
M3010:
	movf 	BYTE,W 
	xorlw 0x4F					; berprfen MAKECODE 4F FA = F10 / F10 (FA)
	btfss STATUS,Z
	goto  M3011
	btfss FLAGTASTEBENE1,0
	goto  M366
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10110110'				; F10
	btfsc FLAGTASTEBENE2,7
	movlw	B'10110110'				; F10
	call	AUSGABE
	goto	ENDE	
M366:	
	btfss FLAGTASTEBENE2,7
	movlw	B'00110110'				; F10
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00110110'				; F10
	call	AUSGABE
	goto	ENDE

M3011:
	movf 	BYTE,W 
	xorlw 0x56					; berprfen MAKECODE 56 FB = F11 / F11 (FB)
	btfss STATUS,Z
	goto  M3012
	btfss FLAGTASTEBENE1,0
	goto  M367
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10110100'				; F11
	btfsc FLAGTASTEBENE2,7
	movlw	B'10110100'				; F11
	call	AUSGABE
	goto	ENDE	
M367:	
	btfss FLAGTASTEBENE2,7
	movlw	B'00110100'				; F11
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00110100'				; F11
	call	AUSGABE
	goto	ENDE

M3012:
	movf 	BYTE,W 
	xorlw 0x5E					; berprfen MAKECODE 5E FC = F12 / F12 (FC)
	btfss STATUS,Z
	goto  M3013
	btfss FLAGTASTEBENE1,0
	goto  M368
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10111010'				; F12
	btfsc FLAGTASTEBENE2,7
	movlw	B'10111010'				; F12 
	call	AUSGABE
	goto	ENDE	
M368:
	btfss FLAGTASTEBENE2,7
	movlw	B'00111010'				; F12
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00111010'				; F12
	call	AUSGABE
	goto	ENDE
;		
;******************************************************************************************
; ENDE 1. Reihe													*
;******************************************************************************************
;
M3013:
	movf 	BYTE,W 
	xorlw 0x0E					; berprfen MAKECODE 0E = ^ / 
	btfss STATUS,Z
	goto  M3014
	btfss FLAGTASTEBENE1,0	
	goto M350
	btfss FLAGTASTEBENE2,7
	movlw	B'10011100'				;  Glocke
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01101000'				; ^
	call	AUSGABE
	goto	ENDE	
M350:	
	btfss FLAGTASTEBENE2,7
	movlw	B'11101000'				; ^
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00011100'				;  Glocke	
	call	AUSGABE
	goto	ENDE

M3014:
	movf 	BYTE,W 
	xorlw 0x16					; berprfen MAKECODE 16 = 1 / !
	btfss STATUS,Z
	goto  M3015
	btfss FLAGTASTEBENE2,7
	movlw	B'10101110'				; 1
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00101110'				; !
	call	AUSGABE
	goto	ENDE

M3015:
	movf 	BYTE,W 
	xorlw 0x1E					; berprfen MAKECODE 1E = 2 / "
	btfss STATUS,Z
	goto  M3016
	btfss FLAGTASTEBENE2,7
	movlw	B'10100000'				; 2
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00100000'				; "
	call	AUSGABE
	goto	ENDE

M3016:
	movf 	BYTE,W 
	xorlw 0x26					; berprfen MAKECODE 26 = 3 /  
	btfss STATUS,Z
	goto  M3017
	btfss FLAGTASTEBENE1,0	
	goto M351
	btfss FLAGTASTEBENE2,7
	goto 	ENDE					; ohne Ausgabe
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00101000'				; 3  
	call	AUSGABE
	goto	ENDE	
M351:	
	btfss FLAGTASTEBENE2,7
	movlw	B'10101000'				; 3
	btfsc	FLAGTASTEBENE2,7			;	
	goto 	ENDE					; ohne Ausgabe
	call	AUSGABE
	goto	ENDE

M3017:
	movf 	BYTE,W 
	xorlw 0x25					; berprfen MAKECODE 25 = 4 / $
	btfss STATUS,Z
	goto  M3018
	btfss FLAGTASTEBENE2,7
	movlw	B'10100110'				; 4
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00100110'				; $
	call	AUSGABE
	goto	ENDE

M3018:
	movf 	BYTE,W 
	xorlw 0x2E					; berprfen MAKECODE 2E = 5 / %
	btfss STATUS,Z
	goto  M3019
	btfss FLAGTASTEBENE2,7
	movlw	B'10100100'				; 5
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00100100'				; %
	call	AUSGABE
	goto	ENDE

M3019:
	movf 	BYTE,W 
	xorlw 0x36					; berprfen MAKECODE 36 = 6 / &
	btfss STATUS,Z
	goto  M3020
	btfss FLAGTASTEBENE2,7
	movlw	B'10101010'				; 6
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00101010'				; &
	call	AUSGABE
	goto	ENDE

M3020:
	movf 	BYTE,W 
	xorlw 0x3D					; berprfen MAKECODE 3D = 7 / /
	btfss STATUS,Z
	goto  M3021
	btfss FLAGTASTEBENE1,0
	goto  M352
	movlw	B'01010110'				; / (')( mit Shift gedrckt )
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00101100'				; 7 (?) (ohne Caps und Shift )
	call	AUSGABE
	goto	ENDE
M352:
	btfss FLAGTASTEBENE2,7
	movlw	B'10101100'				; 7 (ohne Caps und Shift )
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'11010110'				; / ( mit Shift gedrckt )
	call	AUSGABE
	goto	ENDE

M3021:
	movf 	BYTE,W 
	xorlw 0x3E					; berprfen MAKECODE 3E = 8 / (
	btfss STATUS,Z
	goto  M3022
	btfss FLAGTASTEBENE2,7
	movlw	B'10100010'				; 8
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00100010'				; (
	call	AUSGABE
	goto	ENDE

M3022:
	movf 	BYTE,W 
	xorlw 0x46					; berprfen MAKECODE 46 = 9 / )
	btfss STATUS,Z
	goto  M3023
	btfss FLAGTASTEBENE2,7
	movlw	B'11011100'				; 9
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01011100'				; )
	call	AUSGABE
	goto	ENDE

M3023:
	movf 	BYTE,W 
	xorlw 0x45					; berprfen MAKECODE 45 = 0 / =
	btfss STATUS,Z
	goto  M3024
	btfss FLAGTASTEBENE1,0
	goto  M353	
	btfss	FLAGTASTEBENE2,7			;	
	movlw	B'11010000'				; =	
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010100'				; 0
	call	AUSGABE
	goto	ENDE	
M353:	
	btfss FLAGTASTEBENE2,7
	movlw	B'11010100'				; 0
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01010000'				; =
	call	AUSGABE
	goto	ENDE

M3024:
	movf 	BYTE,W 
	xorlw 0x4E					; berprfen MAKECODE 4E FB =   / ?
	btfss STATUS,Z
	goto  M3025
	btfss FLAGTASTEBENE1,0
	goto  M354	
	btfss	FLAGTASTEBENE2,7			;	
	movlw	B'11010110'				; ?	
	btfsc FLAGTASTEBENE2,7
	goto  ENDE					; keine Anzeige	
	call	AUSGABE
	goto	ENDE	
M354:	
	btfss FLAGTASTEBENE2,7
	goto  ENDE					; keine Anzeige
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01010110'				; ?
	call	AUSGABE
	goto	ENDE

M3025:
	movf 	BYTE,W 
	xorlw 0x55					; berprfen MAKECODE 55 =   / `    nicht bearbeitet
	btfss STATUS,Z
	goto  M3026	
;	btfss FLAGTASTEBENE2,7
;	movlw	B'11000000'				;
;	btfsc	FLAGTASTEBENE2,7			;	
;	movlw	B'01000000'				;
;	call	AUSGABE		
	goto	ENDE
M3026:	
	movf 	BYTE,W 
	xorlw 0x5C					; berprfen MAKECODE 5C =  # / '
	btfss STATUS,Z
	goto  M3027	
	btfss FLAGTASTEBENE1,0
	goto  M355	
	btfss	FLAGTASTEBENE2,7			;	
	movlw	B'10101100'				; '
	btfsc FLAGTASTEBENE2,7
	movlw	B'10101000'				; #
	call	AUSGABE	
	goto	ENDE		
M355:	
	btfss FLAGTASTEBENE2,7
	movlw	B'00101000'				; #
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00101100'				; '
	call	AUSGABE	
	goto	ENDE
;		
;******************************************************************************************
; ENDE 2. Reihe													*
;******************************************************************************************
;
M3027:
	movf 	BYTE,W 
	xorlw 0x15					; berprfen MAKECODE 15 =  Q / q
	btfss STATUS,Z
	goto  M3028	
	btfsc FLAGTASTEBENE1,5			; L ALT @
	goto  M384	
	btfss FLAGTASTEBENE2,7
	movlw	B'10001110'				; Q
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00001110'				; q
	call	AUSGABE	
	goto	ENDE
M384:
	btfss FLAGTASTEBENE1,0
	goto  M385
	btfss	FLAGTASTEBENE2,7			;	
	movlw	B'11010100'				; @
	btfsc FLAGTASTEBENE2,7
	movlw	B'11010100'				; @
	call	AUSGABE	
	goto	ENDE		
M385:	
	btfss FLAGTASTEBENE2,7
	movlw	B'01010100'				; @
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01010100'				; @
	call	AUSGABE	
	goto	ENDE
M3028:
	movf 	BYTE,W 
	xorlw 0x1D					; berprfen MAKECODE 1D =  W / w
	btfss STATUS,Z
	goto  M3029	
	btfss FLAGTASTEBENE2,7
	movlw	B'10000000'				; W
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00000000'				; w
	call	AUSGABE	
	goto	ENDE

M3029:
	movf 	BYTE,W 
	xorlw 0x24					; berprfen MAKECODE 24 =  E / e
	btfss STATUS,Z
	goto  M3030	
	btfss FLAGTASTEBENE2,7
	movlw	B'10001000'				; E
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00001000'				; e
	call	AUSGABE	
	goto	ENDE
M3030:
	movf 	BYTE,W 
	xorlw 0x2D					; berprfen MAKECODE 2D =  R / r
	btfss STATUS,Z
	goto  M3031	
	btfss FLAGTASTEBENE2,7
	movlw	B'10000110'				; R
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00000110'				; r
	call	AUSGABE	
	goto	ENDE
M3031:
	movf 	BYTE,W 
	xorlw 0x2C					; berprfen MAKECODE 2C =  T / t
	btfss STATUS,Z
	goto  M3032	
	btfss FLAGTASTEBENE2,7
	movlw	B'10000100'				; T
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00000100'				; t
	call	AUSGABE	
	goto	ENDE
M3032:
	movf 	BYTE,W 
	xorlw 0x35					; berprfen MAKECODE 35 =  Z / z mit Y getauscht
	btfss STATUS,Z
	goto  M3033	
	btfss FLAGTASTEBENE2,7
	movlw	B'10001010'				; Z
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00001010'				; z
	call	AUSGABE	
	goto	ENDE
M3033:
	movf 	BYTE,W 
	xorlw 0x3C					; berprfen MAKECODE 3C =  U / u
	btfss STATUS,Z
	goto  M3034	
	btfss FLAGTASTEBENE2,7
	movlw	B'10001100'				; U
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00001100'				; u
	call	AUSGABE	
	goto	ENDE
M3034:
	movf 	BYTE,W 
	xorlw 0x43					; berprfen MAKECODE 43 =  I / i
	btfss STATUS,Z
	goto  M3035	
	btfss FLAGTASTEBENE2,7
	movlw	B'10000010'				; I
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00000010'				; i
	call	AUSGABE	
	goto	ENDE
M3035:
	movf 	BYTE,W 
	xorlw 0x44					; berprfen MAKECODE 44 =  O / o
	btfss STATUS,Z
	goto  M3036	
	btfss FLAGTASTEBENE2,7
	movlw	B'11101100'				; O
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01101100'				; o
	call	AUSGABE	
	goto	ENDE
M3036:
	movf 	BYTE,W 
	xorlw 0x4D					; berprfen MAKECODE 4D =  P / p
	btfss STATUS,Z
	goto  M3037	
	btfss FLAGTASTEBENE2,7
	movlw	B'11100100'				; P
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01100100'				; p
	call	AUSGABE	
	goto	ENDE
M3037:
	movf 	BYTE,W 
	xorlw 0x54					; berprfen MAKECODE 54 =   /     nicht bearbeitet
	btfss STATUS,Z
	goto  M3038	
;	btfss FLAGTASTEBENE2,7
;	movlw	B'11000000'				;
;	btfsc	FLAGTASTEBENE2,7			;	
;	movlw	B'01000000'				;
;	call	AUSGABE		
	goto	ENDE
M3038:
	movf 	BYTE,W 
	xorlw 0x5B					; berprfen MAKECODE 5B =  + / *
	btfss STATUS,Z
	goto  M3039	
	btfsc FLAGTASTEBENE1,5			; L ALT @
	goto  M386	
	btfss FLAGTASTEBENE1,0
	goto  M369
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11011000'				; *
	btfsc FLAGTASTEBENE2,7
	movlw	B'00010110'				; + 
	call	AUSGABE
	goto	ENDE	
M369:
	btfss FLAGTASTEBENE2,7
	movlw	B'10010110'				; +
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01011000'				; *
	call	AUSGABE	
	goto	ENDE

M386:
	btfss FLAGTASTEBENE1,0
	goto  M387
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11101000'				; ~
	btfsc FLAGTASTEBENE2,7
	movlw	B'11101000'				; ~ 
	call	AUSGABE
	goto	ENDE	
M387:
	btfss FLAGTASTEBENE2,7
	movlw	B'01101000'				; ~
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01101000'				; ~
	call	AUSGABE	
	goto	ENDE
;		
;******************************************************************************************
; ENDE 3. Reihe													*
;******************************************************************************************
;
M3039:
	movf 	BYTE,W 
	xorlw 0x1C					; berprfen MAKECODE 1C =  A / a
	btfss STATUS,Z
	goto  M3040	
	btfss FLAGTASTEBENE2,7
	movlw	B'11000000'				; A
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01000000'				; a
	call	AUSGABE	
	goto	ENDE
M3040:
	movf 	BYTE,W 
	xorlw 0x1B					; berprfen MAKECODE 1B =  S / s
	btfss STATUS,Z
	goto  M3041	
	btfss FLAGTASTEBENE2,7
	movlw	B'11001000'				; S
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01001000'				; s
	call	AUSGABE	
	goto	ENDE
M3041:
	movf 	BYTE,W 
	xorlw 0x23					; berprfen MAKECODE 23 =  D / d
	btfss STATUS,Z
	goto  M3042	
	btfss FLAGTASTEBENE2,7
	movlw	B'11000110'				; D
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01000110'				; d
	call	AUSGABE	
	goto	ENDE
M3042:
	movf 	BYTE,W 
	xorlw 0x2B					; berprfen MAKECODE 2B =  F / f
	btfss STATUS,Z
	goto  M3043	
	btfss FLAGTASTEBENE2,7
	movlw	B'11000100'				; F
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01000100'				; f
	call	AUSGABE	
	goto	ENDE
M3043:
	movf 	BYTE,W 
	xorlw 0x34					; berprfen MAKECODE 34 =  G / g
	btfss STATUS,Z
	goto  M3044	
	btfss FLAGTASTEBENE2,7
	movlw	B'11001010'				; G
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01001010'				; g
	call	AUSGABE	
	goto	ENDE
M3044:
	movf 	BYTE,W 
	xorlw 0x33					; berprfen MAKECODE 33 =  H / h
	btfss STATUS,Z
	goto  M3045	
	btfss FLAGTASTEBENE2,7
	movlw	B'11001100'				; H
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01001100'				; h
	call	AUSGABE	
	goto	ENDE
M3045:
	movf 	BYTE,W 
	xorlw 0x3B					; berprfen MAKECODE 3B =  J / j
	btfss STATUS,Z
	goto  M3046	
	btfss FLAGTASTEBENE2,7
	movlw	B'11000010'				; J
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01000010'				; j
	call	AUSGABE	
	goto	ENDE
M3046:
	movf 	BYTE,W 
	xorlw 0x42					; berprfen MAKECODE 42 =  K / k
	btfss STATUS,Z
	goto  M3047	
	btfss FLAGTASTEBENE2,7
	movlw	B'10010010'				; K
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00010010'				; k
	call	AUSGABE	
	goto	ENDE
M3047:
	movf 	BYTE,W 
	xorlw 0x4B					; berprfen MAKECODE 4B =  L / l
	btfss STATUS,Z
	goto  M3048	
	btfss FLAGTASTEBENE2,7
	movlw	B'10011010'				; L
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'00011010'				; l
	call	AUSGABE	
	goto	ENDE
M3048:
	movf 	BYTE,W 
	xorlw 0x4C					; berprfen MAKECODE 4C =   / 
	btfss STATUS,Z
	goto  M3049	
;	btfss FLAGTASTEBENE2,7
;	movlw	B'11000000'				;
;	btfsc	FLAGTASTEBENE2,7			;	
;	movlw	B'01000000'				;
;	call	AUSGABE	
	goto	ENDE
M3049:
	movf 	BYTE,W 
	xorlw 0x52					; berprfen MAKECODE 52 =   / 
	btfss STATUS,Z
	goto  M3050	
;	btfss FLAGTASTEBENE2,7
;	movlw	B'11000000'				;
;	btfsc	FLAGTASTEBENE2,7			;	
;	movlw	B'01000000'				;
;	call	AUSGABE	
	goto	ENDE
;		
;******************************************************************************************
; ENDE 4. Reihe													*
;******************************************************************************************
;
M3050:
	movf 	BYTE,W 
	xorlw 0x13					; berprfen MAKECODE 13 =  < / >
	btfss STATUS,Z
	goto  M3051	
	btfsc FLAGTASTEBENE1,5			; L ALT |
	goto  M389	
	btfss FLAGTASTEBENE1,0
	goto  M388
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11011010'				; >
	btfsc FLAGTASTEBENE2,7
	movlw	B'11010010'				; < 
	call	AUSGABE
	goto	ENDE	
M388:
	btfss FLAGTASTEBENE2,7
	movlw	B'01010010'				; <
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01011010'				; >
	call	AUSGABE	
	goto	ENDE

M389:
	btfss FLAGTASTEBENE1,0
	goto  M390
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11100110'				; |
	btfsc FLAGTASTEBENE2,7
	movlw	B'11100110'				; | 
	call	AUSGABE
	goto	ENDE	
M390:
	btfss FLAGTASTEBENE2,7
	movlw	B'01100110'				; |
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01100110'				; |
	call	AUSGABE	
	goto	ENDE
M3051:
	movf 	BYTE,W 
	xorlw 0x1A					; berprfen MAKECODE 1A =  Y / y  mit Z getauscht
	btfss STATUS,Z
	goto  M3052	
	btfss FLAGTASTEBENE2,7
	movlw	B'11110000'				; Y
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01110000'				; y
	call	AUSGABE	
	goto	ENDE

M3052:
	movf 	BYTE,W 
	xorlw 0x22					; berprfen MAKECODE 22 =  X / x
	btfss STATUS,Z
	goto  M3053	
	btfss FLAGTASTEBENE2,7
	movlw	B'11111000'				; X
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01111000'				; x
	call	AUSGABE	
	goto	ENDE

M3053:
	movf 	BYTE,W 
	xorlw 0x21					; berprfen MAKECODE 21 =  C / c
	btfss STATUS,Z
	goto  M3054	
	btfss FLAGTASTEBENE2,7
	movlw	B'11110110'				; C
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01110110'				; c
	call	AUSGABE	
	goto	ENDE

M3054:
	movf 	BYTE,W 
	xorlw 0x2A					; berprfen MAKECODE 2A =  V / v
	btfss STATUS,Z
	goto  M3055	
	btfss FLAGTASTEBENE2,7
	movlw	B'11110100'				; V
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01110100'				; v
	call	AUSGABE	
	goto	ENDE

M3055:
	movf 	BYTE,W 
	xorlw 0x32					; berprfen MAKECODE 32 =  B / b
	btfss STATUS,Z
	goto  M3056	
	btfss FLAGTASTEBENE2,7
	movlw	B'11111010'				; B
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01111010'				; b
	call	AUSGABE	
	goto	ENDE

M3056:
	movf 	BYTE,W 
	xorlw 0x31					; berprfen MAKECODE 31 =  N / n
	btfss STATUS,Z
	goto  M3057	
	btfss FLAGTASTEBENE2,7
	movlw	B'11111100'				; N
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01111100'				; n
	call	AUSGABE	
	goto	ENDE

M3057:
	movf 	BYTE,W 
	xorlw 0x3A					; berprfen MAKECODE 3A =  M / m
	btfss STATUS,Z
	goto  M3058	
	btfss FLAGTASTEBENE2,7
	movlw	B'11110010'				; M
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01110010'				; m
	call	AUSGABE	
	goto	ENDE

M3058:
	movf 	BYTE,W 
	xorlw 0x41					; berprfen MAKECODE 41 =  , / ;
	btfss STATUS,Z
	goto  M3059	

	btfss FLAGTASTEBENE1,0
	goto  M370
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10010110'				; ;
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010010'				; , 
	call	AUSGABE
	goto	ENDE	
M370:		
	btfss FLAGTASTEBENE2,7
	movlw	B'11010010'				; ,
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00010110'				; ;
	call	AUSGABE	
	goto	ENDE

M3059:
	movf 	BYTE,W 
	xorlw 0x49					; berprfen MAKECODE 49 =  . / :
	btfss STATUS,Z
	goto  M3060	
	btfss FLAGTASTEBENE1,0
	goto  M371
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01011000'				; :
	btfsc FLAGTASTEBENE2,7
	movlw	B'01011010'				; . 
	call	AUSGABE
	goto	ENDE	
M371:	
	btfss FLAGTASTEBENE2,7
	movlw	B'11011010'				; .
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11011000'				; :
	call	AUSGABE	
	goto	ENDE

M3060:
	movf 	BYTE,W 
	xorlw 0x4A					; berprfen MAKECODE 4A =  - / _
	btfss STATUS,Z
	goto  M3061	
	btfss FLAGTASTEBENE1,0
	goto  M372
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01100110'				; _
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010000'				; - 
	call	AUSGABE
	goto	ENDE	
M372:	
	btfss FLAGTASTEBENE2,7
	movlw	B'11010000'				; -
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11100110'				; _
	call	AUSGABE	
	goto	ENDE
;		
;******************************************************************************************
; ENDE 5. Reihe													*
;******************************************************************************************
;
M3061:
	movf 	BYTE,W 
	xorlw 0x29					; berprfen MAKECODE 29 =  Space / Space
	btfss STATUS,Z
	goto  M3062	
	btfss FLAGTASTEBENE1,0
	goto  M373
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11100010'				; Space
	btfsc FLAGTASTEBENE2,7
	movlw	B'01100010'				; Space 
	call	AUSGABE
	goto	ENDE	
M373:
	btfss FLAGTASTEBENE2,7
	movlw	B'11100010'				; Space
	btfsc	FLAGTASTEBENE2,7			;	
	movlw	B'01100010'				; Space
	call	AUSGABE	
	goto	ENDE
;
;******************************************************************************************
; ENDE 6. Reihe													*
;******************************************************************************************
;
M3062:
	movf 	BYTE,W 
	xorlw 0x61					; berprfen MAKECODE 61 =  Pfeil links
	btfss STATUS,Z
	goto  M3063	
	btfss FLAGTASTEBENE1,0
	goto  M374
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11100000'				;
	btfsc FLAGTASTEBENE2,7
	movlw	B'01100000'				; 
	call	AUSGABE
	goto	ENDE	
M374:
	btfss FLAGTASTEBENE2,7
	movlw	B'11100000'				;W
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01100000'				;w
	call	AUSGABE	
	goto	ENDE
M3063:
	movf 	BYTE,W 
	xorlw 0x6A					; berprfen MAKECODE 6A =  Pfeil rechts
	btfss STATUS,Z
	goto  M3064	
	btfss FLAGTASTEBENE1,0
	goto  M375
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11011110'				;
	btfsc FLAGTASTEBENE2,7
	movlw	B'01011110'				; 
	call	AUSGABE
	goto	ENDE	
M375:
	btfss FLAGTASTEBENE2,7
	movlw	B'11011110'				;
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01011110'				;
	call	AUSGABE	
	goto	ENDE
M3064:
	movf 	BYTE,W 
	xorlw 0x63					; berprfen MAKECODE 63 =  Pfeil hoch
	btfss STATUS,Z
	goto  M3065	
	btfss FLAGTASTEBENE1,0
	goto  M376
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10011110'				;
	btfsc FLAGTASTEBENE2,7
	movlw	B'00011110'				; 
	call	AUSGABE
	goto	ENDE	
M376:
	btfss FLAGTASTEBENE2,7
	movlw	B'10011110'				;
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00011110'				;
	call	AUSGABE	
	goto	ENDE
M3065:
	movf 	BYTE,W 
	xorlw 0x60					; berprfen MAKECODE 60 =  Pfeil runter
	btfss STATUS,Z
	goto  M3066	
	btfss FLAGTASTEBENE1,0
	goto  M377
	btfss	FLAGTASTEBENE2,7			; mit Caps
	movlw	B'11101110'				;
	btfsc FLAGTASTEBENE2,7
	movlw	B'01101110'				; 
	call	AUSGABE
	goto	ENDE	
M377:							
	btfss FLAGTASTEBENE2,7			; ohne Caps
	movlw	B'11101110'				;
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01101110'				;
	call	AUSGABE	
	goto	ENDE
;
;******************************************************************************************
; ENDE Pfeiltasten												*
;******************************************************************************************
;
M3066:
	movf 	BYTE,W 
	xorlw 0x65					; berprfen MAKECODE 65 = BRK
	btfss STATUS,Z
	goto  M3067							
	btfss FLAGTASTEBENE2,7			; ohne Caps
	movlw	B'10111100'				; BRK
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00111100'				; BRK
	call	AUSGABE	
	goto	ENDE
M3067:
	movf 	BYTE,W 
	xorlw 0x62					; berprfen MAKECODE 62 =  STOP
	btfss STATUS,Z
	goto  M3068						
	btfss FLAGTASTEBENE2,7			; ohne Caps
	movlw	B'10110010'				; STOP
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00110010'				; STOP
	call	AUSGABE	
	goto	ENDE
M3068:
	movf 	BYTE,W 
	xorlw 0x67					; berprfen MAKECODE 67 = INS
	btfss STATUS,Z
	goto  M3069	
	btfss FLAGTASTEBENE1,0
	goto  M381
	btfss	FLAGTASTEBENE2,7			; mit Caps
	movlw	B'00011100'				; INS
	btfsc FLAGTASTEBENE2,7
	movlw	B'00011100'				; INS
	call	AUSGABE
	goto	ENDE	
M381:							
	btfss FLAGTASTEBENE2,7			; ohne Caps
	movlw	B'10011100'				; INS
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10011100'				; INS
	call	AUSGABE	
	goto	ENDE
M3069:
	movf 	BYTE,W 
	xorlw 0x64					; berprfen MAKECODE 64 = DEL
	btfss STATUS,Z
	goto  M3070	
	btfss FLAGTASTEBENE1,0
	goto  M382
	btfss	FLAGTASTEBENE2,7			; mit Caps
	movlw	B'10010100'				; DEL
	btfsc FLAGTASTEBENE2,7
	movlw	B'00010100'				; DEL
	call	AUSGABE
	goto	ENDE	
M382:							
	btfss FLAGTASTEBENE2,7			; ohne Caps
	movlw	B'10010100'				; DEL
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00010100'				; DEL
	call	AUSGABE	
	goto	ENDE
M3070:
	movf 	BYTE,W 
	xorlw 0x6E					; berprfen MAKECODE 6E = HOME
	btfss STATUS,Z
	goto  M3071	
	btfss FLAGTASTEBENE1,0
	goto  M383
	btfss	FLAGTASTEBENE2,7			; mit Caps
	movlw	B'10010000'				; CLS
	btfsc FLAGTASTEBENE2,7
	movlw	B'00010000'				; HOME
	call	AUSGABE
	goto	ENDE	
M383:							
	btfss FLAGTASTEBENE2,7			; ohne Caps
	movlw	B'10010000'				; HOME
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'00010000'				; CLS
	call	AUSGABE	
	goto	ENDE
;		
;******************************************************************************************
; Ende BRK, STOP, INS, DEL, HOME										*
;******************************************************************************************
;
;******************************************************************************************
; Anfang  / * - + 7 8 9 4 5 6 1 2 3 0 ,  ( NUM LOCK TASTEN )					*
;******************************************************************************************
;
M3071:
	movf 	BYTE,W 
	xorlw 0x77					; berprfen MAKECODE 77 =  KP / ist o.k.
	btfss STATUS,Z
	goto  M3072	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M392	
	btfss FLAGTASTEBENE1,0
	goto  M391
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01010110'				; /   	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010110'				; /    	3. (ohne NUM mit CAPS ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M391:
	btfss FLAGTASTEBENE2,7
	movlw	B'11010110'				; /    	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11010110'				; /     	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M392:
	btfss FLAGTASTEBENE1,0
	goto  M393
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01010110'				; /   	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010110'				; /  		7. (mit NUM mit CAPS und ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M393:
	btfss FLAGTASTEBENE2,7
	movlw	B'11010110'				; / 		5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11010110'				; / 		6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3072:
	movf 	BYTE,W 
	xorlw 0x7E					; berprfen MAKECODE 7E =  KP * ist o.k.
	btfss STATUS,Z
	goto  M3073	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M395	
	btfss FLAGTASTEBENE1,0
	goto  M394
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11011000'				; *   	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'11011000'				; *    	3. (ohne NUM mit CAPS ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M394:
	btfss FLAGTASTEBENE2,7
	movlw	B'01011000'				; *    	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01011000'				; *     	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M395:
	btfss FLAGTASTEBENE1,0
	goto  M396
	btfss	FLAGTASTEBENE2,7	
	movlw	B'11011000'				; *   	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'11011000'				; *   	7. (mit NUM mit CAPS und ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M396:
	btfss FLAGTASTEBENE2,7
	movlw	B'01011000'				; * 		5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'01011000'				; * 		6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3073:
	movf 	BYTE,W 
	xorlw 0x84					; berprfen MAKECODE 84 =  KP -
	btfss STATUS,Z
	goto  M3074	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M398	
	btfss FLAGTASTEBENE1,0
	goto  M397
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01010000'				; -   	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010000'				; -    	3. (ohne NUM mit CAPS ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M397:
	btfss FLAGTASTEBENE2,7
	movlw	B'11010000'				; -    	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11010000'				; -     	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M398:
	btfss FLAGTASTEBENE1,0
	goto  M399
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01010000'				; -   	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010000'				; -   	7. (mit NUM mit CAPS und ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M399:
	btfss FLAGTASTEBENE2,7
	movlw	B'11010000'				; - 		5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11010000'				; - 		6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3074:
	movf 	BYTE,W 
	xorlw 0x7C					; berprfen MAKECODE 7C =  KP + ist o.k.
	btfss STATUS,Z
	goto  M3075	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M461	
	btfss FLAGTASTEBENE1,0
	goto  M460
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00010110'				; +   	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'00010110'				; +    	3. (ohne NUM mit CAPS ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M460:
	btfss FLAGTASTEBENE2,7
	movlw	B'10010110'				; +    	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10010110'				; +     	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M461:
	btfss FLAGTASTEBENE1,0
	goto  M462
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00010110'				; +   	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'00010110'				; +   	7. (mit NUM mit CAPS und ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M462:
	btfss FLAGTASTEBENE2,7
	movlw	B'10010110'				; + 		5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10010110'				; + 		6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3075:
	movf 	BYTE,W 
	xorlw 0x71					; berprfen MAKECODE 71 =  KP ' ist o.k.
	btfss STATUS,Z
	goto  M3076	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M454	
	btfss FLAGTASTEBENE1,0
	goto  M403
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10010100'				; DEL   	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'10010100'				; Entf    	3. (ohne NUM mit CAPS ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M403:
	btfss FLAGTASTEBENE2,7
	movlw	B'10010100'				; Entf    	1. (ohne NUM CAPS SHIFT) x
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10010100'				; DEL     	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M454:
	btfss FLAGTASTEBENE1,0
	goto  M455
	btfss	FLAGTASTEBENE2,7	
	movlw	B'10010100'				; Entf	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010010'				; ,   	7. (mit NUM mit CAPS und ohne SHIFT) x
	call	AUSGABE
	goto	ENDE	
M455:
	btfss FLAGTASTEBENE2,7
	movlw	B'11010010'				; , 		5. (mit NUM ohne CAPS und ohne SHIFT) x
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10010100'				; DEL		6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3076:
	movf 	BYTE,W 
	xorlw 0x70					; berprfen MAKECODE 70 =  KP 0 IST o.k.
	btfss STATUS,Z
	goto  M3077	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M457	
	btfss FLAGTASTEBENE1,0
	goto  M456
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00011100'				; Einfg   	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
;	movlw	B'11010010'				; ohne    	3. (ohne NUM mit CAPS ohne SHIFT) X
	goto  ENDE
	call	AUSGABE
	goto	ENDE	
M456:
	btfss FLAGTASTEBENE2,7
;	movlw	B'01010010'				; ohne    	1. (ohne NUM CAPS SHIFT) x
	goto  ENDE
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10011100'				; Einfg    	2. (ohne NUM CAPS mit SHIFT) x
	call	AUSGABE	
	goto	ENDE
M457:
	btfss FLAGTASTEBENE1,0
	goto  M408
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'11100110'				; ohne	8. (mit NUM CAPS und SHIFT)
	goto  ENDE
	btfsc FLAGTASTEBENE2,7
	movlw	B'01010100'				; 0  		7. (mit NUM mit CAPS und ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M408:
	btfss FLAGTASTEBENE2,7
	movlw	B'11010100'				; 0 		5. (mit NUM ohne CAPS und ohne SHIFT) x
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'01100110'				; ohne 	6. (mit NUM ohne CAPS und mit SHIFT) x
	goto  ENDE
	call	AUSGABE	
	goto	ENDE
M3077:
	movf 	BYTE,W 
	xorlw 0x69					; berprfen MAKECODE 69 =  KP 1
	btfss STATUS,Z
	goto  M3078	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M410	
	btfss FLAGTASTEBENE1,0
	goto  M409
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'11011010'				; ohne   	4. (ohne NUM mit CAPS mit SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
;	movlw	B'11010010'				; ohne    	3. (ohne NUM mit CAPS ohne SHIFT) 
	goto	ENDE
	call	AUSGABE
	goto	ENDE	
M409:
	btfss FLAGTASTEBENE2,7
;	movlw	B'01010010'				; ohne    	1. (ohne NUM CAPS SHIFT)
	goto	ENDE
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'01011010'				; ohne    	2. (ohne NUM CAPS mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE

M410:
	btfss FLAGTASTEBENE1,0
	goto  M411
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'11100110'				; ohne	8. (mit NUM CAPS und SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
	movlw	B'00101110'				; 1  		7. (mit NUM mit CAPS und ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M411:
	btfss FLAGTASTEBENE2,7
	movlw	B'10101110'				; 1 		5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'01100110'				; ohne 	6. (mit NUM ohne CAPS und mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE
M3078:
	movf 	BYTE,W 
	xorlw 0x72					; berprfen MAKECODE 72 =  KP 2 ist o.k.
	btfss STATUS,Z
	goto  M3079	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M413	
	btfss FLAGTASTEBENE1,0
	goto  M412
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01101110'				; Pfeil runter	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01101110'				; Pfeil runter	3. (ohne NUM mit CAPS ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M412:
	btfss FLAGTASTEBENE2,7
	movlw	B'11101110'				; Pfeil runter	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11101110'				; Pfeil runter	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M413:
	btfss FLAGTASTEBENE1,0
	goto  M414
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01101110'				; Pfeil runter	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'00100000'				; 2  			7. (mit NUM mit CAPS und ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M414:
	btfss FLAGTASTEBENE2,7
	movlw	B'10100000'				; 2 			5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11101110'				; Pfeil runter	6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3079:
	movf 	BYTE,W 
	xorlw 0x7A					; berprfen MAKECODE 7A =  KP 3
	btfss STATUS,Z
	goto  M3080	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M416	
	btfss FLAGTASTEBENE1,0
	goto  M415
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'00101000'				; ohne   	4. (ohne NUM mit CAPS mit SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
;	movlw	B'00101000'				; ohne    	3. (ohne NUM mit CAPS ohne SHIFT) 
	goto	ENDE
	call	AUSGABE
	goto	ENDE	
M415:
	btfss FLAGTASTEBENE2,7
;	movlw	B'10101000'				; ohne   	1. (ohne NUM CAPS SHIFT)
	goto	ENDE
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'10101000'				; ohne    	2. (ohne NUM CAPS mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE

M416:
	btfss FLAGTASTEBENE1,0
	goto  M417
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'00101000'				; ohne	8. (mit NUM CAPS und SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
	movlw	B'00101000'				; 3  		7. (mit NUM mit CAPS und ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M417:
	btfss FLAGTASTEBENE2,7
	movlw	B'10101000'				; 3 		5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'10101000'				; ohne	6. (mit NUM ohne CAPS und mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE
M3080:
	movf 	BYTE,W 
	xorlw 0x6B					; berprfen MAKECODE 6B = KP 4 ist o.k
	btfss STATUS,Z
	goto  M3081	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M419	
	btfss FLAGTASTEBENE1,0
	goto  M418
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01100000'				; Pfeil links   	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01100000'				; Pfeil links    	3. (ohne NUM mit CAPS ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M418:
	btfss FLAGTASTEBENE2,7
	movlw	B'11100000'				; Pfeil links   	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11100000'				; Pfeil links    	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M419:
	btfss FLAGTASTEBENE1,0
	goto  M420
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01100000'				; Pfeil links	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'00100110'				; 4  			7. (mit NUM mit CAPS und ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M420:
	btfss FLAGTASTEBENE2,7
	movlw	B'10100110'				; 4 			5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11100000'				; Pfeil links	6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3081:
	movf 	BYTE,W 
	xorlw 0x73					; berprfen MAKECODE 73 =  KP 5 ist o.k.
	btfss STATUS,Z
	goto  M3082	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M422	
	btfss FLAGTASTEBENE1,0
	goto  M421
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'00100100'				; ohne   	4. (ohne NUM mit CAPS mit SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
;	movlw	B'00100100'				; ohne    	3. (ohne NUM mit CAPS ohne SHIFT) 
	goto	ENDE
	call	AUSGABE
	goto	ENDE	
M421:
	btfss FLAGTASTEBENE2,7
;	movlw	B'10100100'				; ohne   	1. (ohne NUM CAPS SHIFT)
	goto	ENDE
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'10100100'				; ohne    	2. (ohne NUM CAPS mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE

M422:
	btfss FLAGTASTEBENE1,0
	goto  M423
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'00100100'				; ohne	8. (mit NUM CAPS und SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
	movlw	B'00100100'				; 5  		7. (mit NUM mit CAPS und ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M423:
	btfss FLAGTASTEBENE2,7
	movlw	B'10100100'				; 5 		5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'10100100'				; ohne 	6. (mit NUM ohne CAPS und mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE
M3082:
	movf 	BYTE,W 
	xorlw 0x74					; berprfen MAKECODE 74 =  KP 6 ist o.k.
	btfss STATUS,Z
	goto  M3083	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M425	
	btfss FLAGTASTEBENE1,0
	goto  M424
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01011110'				; Pfeil rechts	4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'01011110'				; Pfeil rechts	3. (ohne NUM mit CAPS ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M424:
	btfss FLAGTASTEBENE2,7
	movlw	B'11011110'				; Pfeil rechts	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11011110'				; Pfeil rechts	2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE

M425:
	btfss FLAGTASTEBENE1,0
	goto  M426
	btfss	FLAGTASTEBENE2,7	
	movlw	B'01011110'				; Pfeil rechts	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'00101010'				; 6  			7. (mit NUM mit CAPS und ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M426:
	btfss FLAGTASTEBENE2,7
	movlw	B'10101010'				; 6 			5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'11011110'				; Pfeil rechts  	6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3083:
	movf 	BYTE,W 
	xorlw 0x6C					; berprfen MAKECODE 6C =  KP 7
	btfss STATUS,Z
	goto  M3084	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M428	
	btfss FLAGTASTEBENE1,0
	goto  M427
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'10010000'				; ohne   		4. (ohne NUM mit CAPS mit SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
;	movlw	B'00101100'				; ohne	    	3. (ohne NUM mit CAPS ohne SHIFT)
	goto	ENDE
	call	AUSGABE
	goto	ENDE	
M427:
	btfss FLAGTASTEBENE2,7
;	movlw	B'10101100'				; ohne	   	1. (ohne NUM CAPS SHIFT)
	goto	ENDE
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'10010000'				; ohne   		2. (ohne NUM CAPS mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE

M428:
	btfss FLAGTASTEBENE1,0
	goto  M429
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'10010000'				; ohne		8. (mit NUM CAPS und SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
	movlw	B'00101100'				; 7  			7. (mit NUM mit CAPS und ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M429:
	btfss FLAGTASTEBENE2,7
	movlw	B'10101100'				; 7 			5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'10010000'				; ohne  		6. (mit NUM ohne CAPS und mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE
M3084:
	movf 	BYTE,W 
	xorlw 0x75					; berprfen MAKECODE 75 =  KP 8
	btfss STATUS,Z
	goto  M3085	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M431	
	btfss FLAGTASTEBENE1,0
	goto  M430
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00011110'				; Pfeil nach oben 4. (ohne NUM mit CAPS mit SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'00011110'				; Pfeil nach oben 3. (ohne NUM mit CAPS ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M430:
	btfss FLAGTASTEBENE2,7
	movlw	B'10011110'				; Pfeil nach oben	1. (ohne NUM CAPS SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10011110'				; Pfeil nach oben 2. (ohne NUM CAPS mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M431:
	btfss FLAGTASTEBENE1,0
	goto  M432
	btfss	FLAGTASTEBENE2,7	
	movlw	B'00011110'				; Pfeil nach oben	8. (mit NUM CAPS und SHIFT)
	btfsc FLAGTASTEBENE2,7
	movlw	B'00100010'				; 8   		7. (mit NUM mit CAPS und ohne SHIFT) 
	call	AUSGABE
	goto	ENDE	
M432:
	btfss FLAGTASTEBENE2,7
	movlw	B'10100010'				; 8 			5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
	movlw	B'10011110'				; Pfeil nach oben 6. (mit NUM ohne CAPS und mit SHIFT)
	call	AUSGABE	
	goto	ENDE
M3085:
	movf 	BYTE,W 
	xorlw 0x7D					; berprfen MAKECODE 7D =  KP 9
	btfss STATUS,Z
	goto  M7777	
	btfsc FLAGTASTEBENE1,7			; NUM LOCK
	goto  M434	
	btfss FLAGTASTEBENE1,0
	goto  M433
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'01011100'				; ohne	 	4. (ohne NUM mit CAPS mit SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
;	movlw	B'01011100'				; ohne		3. (ohne NUM mit CAPS ohne SHIFT)
	goto	ENDE
	call	AUSGABE
	goto	ENDE	
M433:
	btfss FLAGTASTEBENE2,7
;	movlw	B'11011100'				; ohne		1. (ohne NUM CAPS SHIFT)
	goto	ENDE
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'11011100'				; ohne	 	2. (ohne NUM CAPS mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE
M434:
	btfss FLAGTASTEBENE1,0
	goto  M435
	btfss	FLAGTASTEBENE2,7	
;	movlw	B'01011100'				; ohne	 	8. (mit NUM CAPS und SHIFT)
	goto	ENDE
	btfsc FLAGTASTEBENE2,7
	movlw	B'01011100'				; 9   		7. (mit NUM mit CAPS und ohne SHIFT)
	call	AUSGABE
	goto	ENDE	
M435:
	btfss FLAGTASTEBENE2,7
	movlw	B'11011100'				; 9 			5. (mit NUM ohne CAPS und ohne SHIFT)
	btfsc	FLAGTASTEBENE2,7	
;	movlw	B'11011100'				; ohne		6. (mit NUM ohne CAPS und mit SHIFT)
	goto	ENDE
	call	AUSGABE	
	goto	ENDE
;
;******************************************************************************************
; Ende / * - + 7 8 9 4 5 6 1 2 3 0 ,  ( NUM LOCK TASTEN )						*
;******************************************************************************************
;
M7777:		
		movf 	BYTE,W
		xorlw 0x5A					; berprfen MAKECODE 5A ENTER ( siehe auch http://www.marjorie.de/ps2/scancode-set3.htm )
		btfss STATUS,Z
		goto	M900	
		movlw	B'01111110'				; Enter
		call	AUSGABE
		goto	ENDE
M900:		
		movf 	BYTE,W
		xorlw 0x79					; berprfen MAKECODE 79 KP ENTER ( siehe auch http://www.marjorie.de/ps2/scancode-set3.htm )
		btfss STATUS,Z
		goto	M901
		movlw B'01111110'				; KP Entert
		call	AUSGABE
		goto	ENDE
M901:
		movf 	BYTE,W
		xorlw 0x66					; berprfen MAKECODE 66 BKSP ( siehe auch http://www.marjorie.de/ps2/scancode-set3.htm )
		btfss STATUS,Z
		goto	ENDE	
		btfss FLAGTASTEBENE2,7			; B it = 0 Shift nicht gedrckt
		movlw	B'10011000'				; CLR
		btfsc	FLAGTASTEBENE2,7			; Bit = 1 Shift gedrckt	
		movlw	B'00011000'				; HCOPY		
		call	AUSGABE
		goto 	ENDE
;
;******************************************************************************************
; UP Umschalten zwischen den Bnken										*
;******************************************************************************************
;  	   	
AUSGABE:
		movwf	DatenBit
  	   	movlw B'00000000'
		movwf	safeW           			; w abspeichern 
		movlw	HIGH (SignalKC85)			; Highteil von tabelle holen
		movwf	PCLATH				; und nach PCLATH damit
		movlw	Low (SignalKC85)			; Lowteil von Tabelle holen
		addwf	safeW,w		
		btfsc	STATUS,C				; berlauf?
		incf	PCLATH,f				; ja, um eins erhhen
		movwf	PCL					; Jump
AUSGABERET:
		return


ENDE:  	   	
  	   	movlw B'00000000'
		movwf	safeW           			; w abspeichern 
		movlw	HIGH (M9999)			; Highteil von tabelle holen
		movwf	PCLATH				; und nach PCLATH damit
		movlw	Low (M9999)				; Lowteil von Tabelle holen
		addwf	safeW,w		
		btfsc	STATUS,C				; berlauf?
		incf	PCLATH,f				; ja, um eins erhhen
		movwf	PCL					; Jump

LED:
		movlw B'00000000'
		movwf	safeW           			; w abspeichern 
		movlw	HIGH (LEDTAST)			; Highteil von tabelle holen
		movwf	PCLATH				; und nach PCLATH damit
		movlw	Low (LEDTAST)			; Lowteil von Tabelle holen
		addwf	safeW,w		
		btfsc	STATUS,C				; berlauf?
		incf	PCLATH,f				; ja, um eins erhhen
		movwf	PCL					; Jump
LEDRET:
		return

;
;******************************************************************************************
; UP Umschalten zwischen den Bnken										*
;******************************************************************************************
;
;------------------------------------------------------------------------------------------
;* BANK 2														*
;------------------------------------------------------------------------------------------
;
		ORG 0x1000
PAGE2:
;
;------------------------------------------------------------------------------------------
;* BANK 3 														*
;------------------------------------------------------------------------------------------
;
		ORG 0x1800
PAGE3:
;
;******************************************************************************************
;
;******************************************************************************************
;* Programmende													*
;******************************************************************************************
;
		END						; Ende des Programms		
;		
;******************************************************************************************
